javadoc(1)

NAME
javadoc - Generates HTML pages of API documentation from Java source files.

SYNOPSIS

javadoc {packages|source-files} [options] [@argfiles]

packages
    Names of packages that you want to document, separated by spaces, for example java.lang java.lang.reflect java.awt. If you want to also document the subpackages, use the -subpackages option to specify the packages. By default, javadoc looks for the specified packages in the current directory and subdirectories. Use the -sourcepath option to specify the list of directories where to look for packages.

source-files
    Names of Java source files that you want to document, separated by spaces, for example Class.java Object.java Button.java. By default, javadoc looks for the specified classes in the current directory. However, you can specify the full path to the class file and use wildcard characters, for example /home/src/java/awt/Graphics*.java. You can also specify the path relative to the current directory.

options
    Command-line options, separated by spaces. See Options.

@argfiles
    Names of files that contain a list of javadoc command options, package names and source file names in any order.

DESCRIPTION
The javadoc command parses the declarations and documentation comments in a set of Java source files and produces a corresponding set of HTML pages that describe (by default) the public and protected classes, nested classes (but not anonymous inner classes), interfaces, constructors, methods, and fields. You can use the javadoc command to generate the API documentation or the implementation documentation for a set of source files.

You can run the javadoc command on entire packages, individual source files, or both. When documenting entire packages, you can either use the -subpackages option to recursively traverse a directory and its subdirectories, or to pass in an explicit list of package names. When you document individual source files, pass in a list of Java source file names. See Simple Examples.

  PROCESS SOURCE FILES
The javadoc command processes files that end in source and other files described in Source Files. If you run the javadoc command by passing in individual source file names, then you can determine exactly which source files are processed. However, that is not how most developers want to work, because it is simpler to pass in package names. The javadoc command can be run three ways without explicitly specifying the source file names. You can pass in package names, use the -subpackages option, or use wild cards with source file names. In these cases, the javadoc command processes a source file only when the file fulfills all of the following requirements:

•   The file name prefix (with .java removed) is a valid class name.

•   The path name relative to the root of the source tree is a valid package name after the separators are converted to dots.

•   The package statement contains the valid package name.

Processing Links During a run, the javadoc command adds cross-reference links to package, class, and member names that are being documented as part of that run. Links appear in the following places. See Javadoc Tags for a description of the @ tags.

•   Declarations (return types, argument types, and field types).

•   See Also sections that are generated from @see tags.

•   Inline text generated from {@link} tags.

•   Exception names generated from @throws tags.

•   Specified by links to interface members and Overrides links to class members. See Method Comment Inheritance.

•   Summary tables listing packages, classes and members.

•   Package and class inheritance trees.

•   The index.

You can add links to existing text for classes not included on the command line (but generated separately) by way of the -link and -linkoffline options.

Processing Details The javadoc command produces one complete document every time it runs. It does not do incremental builds that modify or directly incorporate the results from earlier runs. However, the javadoc command can link to results from other runs.

The javadoc command implementation requires and relies on the Java compiler. The javadoc command calls part of the javac command to compile the declarations and ignore the member implementations. The javadoc command builds a rich internal representation of the classes that includes the class hierarchy and use relationships to generate the HTML. The javadoc command also picks up user-supplied documentation from documentation comments in the source code. See Documentation Comments.

The javadoc command runs on source files that are pure stub files with no method bodies. This means you can write documentation comments and run the javadoc command in the early stages of design before API implementation.

Relying on the compiler ensures that the HTML output corresponds exactly with the actual implementation, which may rely on implicit, rather than explicit, source code. For example, the javadoc command documents default constructors that are present in the compiled class files but not in the source code.

In many cases, the javadoc command lets you generate documentation for source files with incomplete or erroneous code. You can generate documentation before all debugging and troubleshooting is done. The javadoc command does primitive checking of documentation comments.

When the javadoc command builds its internal structure for the documentation, it loads all referenced classes. Because of this, the javadoc command must be able to find all referenced classes, whether bootstrap classes, extensions, or user classes. See How Classes Are Found at http://docs.oracle.com/javase/8/docs/technotes/tools/findingclasses.html

Typically, classes you create must either be loaded as an extension or in the javadoc command class path.

  JAVADOC DOCLETS
You can customize the content and format of the javadoc command output with doclets. The javadoc command has a default built-in doclet, called the standard doclet, that generates HTML-formatted API documentation. You can modify or make a subclass of the standard doclet, or write your own doclet to generate HTML, XML, MIF, RTF or whatever output format you want.

When a custom doclet is not specified with the -doclet option, the javadoc command uses the default standard doclet. The javadoc command has several options that are available regardless of which doclet is being used. The standard doclet adds a supplementary set of command-line options. See Options.

SOURCE FILES
The javadoc command generates output that originates from the following types of source files: Java language source files for classes (.java), package comment files, overview comment files, and miscellaneous unprocessed files. This section also describes test files and template files that can also be in the source tree, but that you want to be sure not to document.

  CLASS SOURCE FILES
Each class or interface and its members can have their own documentation comments contained in a source file. See Documentation Comments.

  PACKAGE COMMENT FILES
Each package can have its own documentation comment, contained in its own source file, that the javadoc command merges into the generated package summary page. You typically include in this comment any documentation that applies to the entire package.

To create a package comment file, you can place your comments in one of the following files:

•   The package-info.java file can contain the package declaration, package annotations, package comments, and Javadoc tags. This file is preferred.

•   The package.html file contains only package comments and Javadoc tags. No package annotations.

A package can have a single package.html file or a single package-info.java file, but not both. Place either file in the package directory in the source tree with your source files.

The package-info.java File The package-info.java file can contain a package comment of the following structure. The comment is placed before the package declaration.

Note: The comment separators /** and */ must be present, but the leading asterisks on the intermediate lines can be left off.

/**
 * Provides the classes necessary to create an
 * applet and the classes an applet uses
 * to communicate with its applet context.
 * <p>
 * The applet framework involves two entities:
 * the applet and the applet context.
 * An applet is an embeddable window (see the
 * {@link java.awt.Panel} class) with a few extra
 * methods that the applet context can use to
 * initialize, start, and stop the applet.
 *
 * @since 1.0
 * @see java.awt
 */
package java.lang.applet;

The package.html File The package.html file can contain a package comment of the following structure. The comment is placed in the <body> element.

File: java/applet/package.html

<HTML>
<BODY>
Provides the classes necessary to create an applet and the
classes an applet uses to communicate with its applet context.
<p>
The applet framework involves two entities: the applet
and the applet context. An applet is an embeddable
window (see the {@link java.awt.Panel} class) with a
few extra methods that the applet context can use to
initialize, start, and stop the applet.

@since 1.0
@see java.awt
</BODY>
</HTML>

The package.html file is a typical HTML file and does not include a package declaration. The content of the package comment file is written in HTML with one exception. The documentation comment should not include the comment separators /** and */ or leading asterisks. When writing the comment, make the first sentence a summary about the package, and do not put a title or any other text between the <body> tag and the first sentence. You can include package tags. All block tags must appear after the main description. If you add an @see tag in a package comment file, then it must have a fully qualified name.

Processing the Comment File When the javadoc command runs, it searches for the package comment file. If the package comment file is found, then the javadoc command does the following:

•   Copies the comment for processing. For package.html, the javadoc command copies all content between the <body> and </body> HTML tags. You can include a <head> section to put a <title> tag, source file copyright statement, or other information, but none of these appear in the generated documentation.

•   Processes the package tags. See Package Tags.

•   Inserts the processed text at the bottom of the generated package summary page. See Java Platform, Standard Edition API Specification Overview at http://docs.oracle.com/javase/8/docs/api/overview-summary.html

•   Copies the first sentence of the package comment to the top of the package summary page. The javadoc command also adds the package name and this first sentence to the list of packages on the overview page. See Java Platform, Standard Edition API Specification Overview at http://docs.oracle.com/javase/8/docs/api/overview-summary.html The end of the sentence is determined by the same rules used for the end of the first sentence of class and member main descriptions.

  OVERVIEW COMMENT FILES
Each application or set of packages that you are documenting can have its own overview documentation comment that is kept in its own source file, that the javadoc command merges into the generated overview page. You typically include in this comment any documentation that applies to the entire application or set of packages.

You can name the file anything you want such as overview.html and place it anywhere. A typical location is at the top of the source tree.

For example, if the source files for the java.applet package are contained in the /home/user/src/java/applet directory, then you could create an overview comment file at /home/user/src/overview.html.

You can have multiple overview comment files for the same set of source files in case you want to run the javadoc command multiple times on different sets of packages. For example, you could run the javadoc command once with -private for internal documentation and again without that option for public documentation. In this case, you could describe the documentation as public or internal in the first sentence of each overview comment file.

The content of the overview comment file is one big documentation comment that is written in HTML. Make the first sentence a summary about the application or set of packages. Do not put a title or any other text between the <body> tag and the first sentence. All tags except inline tags, such as an {@link} tag, must appear after the main description. If you add an @see tag, then it must have a fully qualified name.

When you run the javadoc command, specify the overview comment file name with the -overview option. The file is then processed similarly to that of a package comment file. The javadoc command does the following:

•   Copies all content between the <body> and </body> tags for processing.

•   Processes the overview tags that are present. See Overview Tags.

•   Inserts the processed text at the bottom of the generated overview page. See Java Platform Standard Edition API Specification Overview at http://docs.oracle.com/javase/8/docs/api/overview-summary.html

•   Copies the first sentence of the overview comment to the top of the overview summary page.

  UNPROCESSED FILES
Your source files can include any files that you want the javadoc command to copy to the destination directory. These files usually include graphic files, example Java source and class files, and self-standing HTML files with a lot of content that would overwhelm the documentation comment of a typical Java source file.

To include unprocessed files, put them in a directory called doc-files. The doc-files directory can be a subdirectory of any package directory that contains source files. You can have one doc-files subdirectory for each package.

For example, if you want to include the image of a button in the java.awt.Button class documentation, then place the image file in the /home/user/src/java/awt/doc-files/ directory. Do not place the doc-files directory at /home/user/src/java/doc-files, because java is not a package. It does not contain any source files.

All links to the unprocessed files must be included in the code because the javadoc command does not look at the files. The javadoc command copies the directory and all of its contents to the destination. The following example shows how the link in the Button.java documentation comment might look:

/**
 * This button looks like this:
 * <img src="doc-files/Button.gif">
 */

  TEST AND TEMPLATE FILES
You can store test and template files in the source tree in the same directory with or in a subdirectory of the directory where the source files reside. To prevent test and template files from being processed, run the javadoc command and explicitly pass in individual source file names.

Test files are valid, compilable source files. Template files are not valid, compatible source files, but they often have the .java suffix.

Test Files If you want your test files to belong to either an unnamed package or to a package other than the package that the source files are in, then put the test files in a subdirectory underneath the source files and give the directory an invalid name. If you put the test files in the same directory with the source and call the javadoc command with a command-line argument that indicates its package name, then the test files cause warnings or errors. If the files are in a subdirectory with an invalid name, then the test file directory is skipped and no errors or warnings are issued. For example, to add test files for source files in com.package1, put them in a subdirectory in an invalid package name. The following directory name is invalid because it contains a hyphen:

com/package1/test-files/

If your test files contain documentation comments, then you can set up a separate run of the javadoc command to produce test file documentation by passing in their test source file names with wild cards, such as com/package1/test-files/*.java.

Template Files If you want a template file to be in the source directory, but not generate errors when you execute the javadoc command, then give it an invalid file name such as Buffer-Template.java to prevent it from being processed. The javadoc command only processes source files with names, when stripped of the .java suffix, that are valid class names.

GENERATED FILES
By default, the javadoc command uses a standard doclet that generates HTML-formatted documentation. The standard doclet generates basic content, cross-reference, and support pages described here. Each HTML page corresponds to a separate file. The javadoc command generates two types of files. The first type is named after classes and interfaces. The second type contain hyphens (such as package-summary.html) to prevent conflicts with the first type of file.

  BASIC CONTENT PAGES

•   One class or interface page (classname.html) for each class or interface being documented.

•   One package page (package-summary.html) for each package being documented. The javadoc command includes any HTML text provided in a file with the name package.html or package-info.java in the package directory of the source tree.

•   One overview page (overview-summary.html) for the entire set of packages. The overview page is the front page of the generated document. The javadoc command includes any HTML text provided in a file specified by the -overview option. The Overview page is created only when you pass two or more package names into the javadoc command. See HTML Frames and Options.

  CROSS-REFERENCE PAGES

•   One class hierarchy page for the entire set of packages (overview-tree.html). To view the hierarchy page, click Overview in the navigation bar and click Tree.

•   One class hierarchy page for each package (package-tree.html) To view the hierarchy page, go to a particular package, class, or interface page, and click Tree to display the hierarchy for that package.

•   One use page for each package (package-use.html) and a separate use page for each class and interface (class-use/classname.html). The use page describes what packages, classes, methods, constructors and fields use any part of the specified class, interface, or package. For example, given a class or interface A, its use page includes subclasses of A, fields declared as A, methods that return A, and methods and constructors with parameters of type A. To view the use page, go to the package, class, or interface and click the Use link in the navigation bar.

•   A deprecated API page (deprecated-list.html) that lists all deprecated APIs and their suggested replacements. Avoid deprecated APIs because they can be removed in future implementations.

•   A constant field values page (constant-values.html) for the values of static fields.

•   A serialized form page (serialized-form.html) that provides information about serializable and externalizable classes with field and method descriptions. The information on this page is of interest to reimplementors, and not to developers who want to use the API. To access the serialized form page, go to any serialized class and click Serialized Form in the See Also section of the class comment. The standard doclet generates a serialized form page that lists any class (public or non-public) that implements Serializable with its readObject and writeObject methods, the fields that are serialized, and the documentation comments from the @serial, @serialField, and @serialData tags. Public serializable classes can be excluded by marking them (or their package) with @serial exclude, and package-private serializable classes can be included by marking them (or their package) with an @serial include. As of Release 1.4, you can generate the complete serialized form for public and private classes by running the javadoc command without specifying the -private option. See Options.

•   An index page (index-*.html) of all class, interface, constructor, field and method names, in alphabetical order. The index page is internationalized for Unicode and can be generated as a single file or as a separate file for each starting character (such as A–Z for English).

  SUPPORT PAGES

•   A help page (help-doc.html) that describes the navigation bar and the previous pages. Use -helpfile to override the default help file with your own custom help file.

•   One index.html file that creates the HTML frames for display. Load this file to display the front page with frames. The index.html file contains no text content.

•   Several frame files (*-frame.html) that contains lists of packages, classes, and interfaces. The frame files display the HTML frames.

•   A package list file (package-list) that is used by the -link and -linkoffline options. The package list file is a text file that is not reachable through links.

•   A style sheet file (stylesheet.css) that controls a limited amount of color, font family, font size, font style, and positioning information on the generated pages.

•   A doc-files directory that holds image, example, source code, or other files that you want copied to the destination directory. These files are not processed by the javadoc command. This directory is not processed unless it exists in the source tree.

See Options.

  HTML FRAMES
The javadoc command generates the minimum number of frames (two or three) necessary based on the values passed to the command. It omits the list of packages when you pass a single package name or source files that belong to a single package as an argument to the javadoc command. Instead, the javadoc command creates one frame in the left-hand column that displays the list of classes. When you pass two or more package names, the javadoc command creates a third frame that lists all packages and an overview page (overview-summary.html). To bypass frames, click the No Frames link or enter the page set from the overview-summary.html page.

  GENERATED FILE STRUCTURE
The generated class and interface files are organized in the same directory hierarchy that Java source files and class files are organized. This structure is one directory per subpackage.

For example, the document generated for the java.applet.Applet class would be located at java/applet/Applet.html.

The file structure for the java.applet package follows, assuming that the destination directory is named apidocs. All files that contain the word frame appear in the upper-left or lower-left frames, as noted. All other HTML files appear in the right-hand frame.

Directories are bold. The asterisks (*) indicate the files and directories that are omitted when the arguments to the javadoc command are source file names rather than package names. When arguments are source file names, an empty package list is created. The doc-files directory is not created in the destination unless it exists in the source tree. See Generated Files.

•   apidocs: Top-level directory

    •   index.html: Initial Page that sets up HTML frames

    •   *overview-summary.html: Package list with summaries

    •   overview-tree.html: Class hierarchy for all packages

    •   deprecated-list.html: Deprecated APIs for all packages

    •   constant-values.html: Static field values for all packages

    •   serialized-form.html: Serialized forms for all packages

    •   *overview-frame.html: All packages for display in upper-left frame

    •   allclasses-frame.html: All classes for display in lower-left frame

    •   help-doc.html: Help about Javadoc page organization

    •   index-all.html: Default index created without -splitindex option

    •   index-files: Directory created with -splitindex option

        •   index-<number>.html: Index files created with -splitindex option

    •   package-list: Package names for resolving external references

    •   stylesheet.css: Defines fonts, colors, positions, and so on

•   java: Package directory

    •   applet: Subpackage directory

        •   Applet.html: Applet class page

        •   AppletContext.html: AppletContext interface

        •   AppletStub.html: AppletStub interface

        •   AudioClip.html: AudioClip interface

        •   package-summary.html: Classes with summaries

        •   package-frame.html: Package classes for display in lower-left frame

        •   package-tree.html: Class hierarchy for this package

        •   package-use.html: Where this package is used

        •   doc-files: Image and example files directory

        •   class-use: Image and examples file location - Applet.html: Uses of the Applet class - AppletContext.html: Uses of the AppletContext interface - AppletStub.html: Uses of the AppletStub interface - AudioClip.html: Uses of the AudioClip interface

•   src-html: Source code directory

    •   java: Package directory

        •   applet: Subpackage directory - Applet.html: Applet source code - AppletContext.html: AppletContext source code - AppletStub.html: AppletStub source code - AudioClip.html: AudioClip source code

  GENERATED API DECLARATIONS
The javadoc command generates a declaration at the start of each class, interface, field, constructor, and method description for that API item. For example, the declaration for the Boolean class is:

public final class Boolean
extends Object
implements Serializable

The declaration for the Boolean.valueOf method is:

public static Boolean valueOf(String s)

The javadoc command can include the modifiers public, protected, private, abstract, final, static, transient, and volatile, but not synchronized or native. The synchronized and native modifiers are considered implementation detail and not part of the API specification.

Rather than relying on the keyword synchronized, APIs should document their concurrency semantics in the main description of the comment. For example, a description might be: A single enumeration cannot be used by multiple threads concurrently. The document should not describe how to achieve these semantics. As another example, while the Hashtable option should be thread-safe, there is no reason to specify that it is achieved by synchronizing all of its exported methods. It is better to reserve the right to synchronize internally at the bucket level for higher concurrency.

DOCUMENTATION COMMENTS
This section describes source code comments and comment inheritance.

  SOURCE CODE COMMENTS
You can include documentation comments in the source code, ahead of declarations for any class, interface, method, constructor, or field. You can also create documentation comments for each package and another one for the overview, though their syntax is slightly different. A documentation comment consists of the characters between /** and */ that end it. Leading asterisks are allowed on each line and are described further in the following section. The text in a comment can continue onto multiple lines.

/**
 * This is the typical format of a simple documentation comment
 * that spans two lines.
 */

To save space you can put a comment on one line:

/** This comment takes up only one line. */

Placement of Comments Documentation comments are recognized only when placed immediately before class, interface, constructor, method, or field declarations. Documentation comments placed in the body of a method are ignored. The javadoc command recognizes only one documentation comment per declaration statement. See Where Tags Can Be Used.

A common mistake is to put an import statement between the class comment and the class declaration. Do not put an import statement at this location because the javadoc command ignores the class comment.

/**
 * This is the class comment for the class Whatever.
 */

import com.example;   // MISTAKE - Important not to put import statement here

public class Whatever{ }

Parts of Comments A documentation comment has a main description followed by a tag section. The main description begins after the starting delimiter /** and continues until the tag section. The tag section starts with the first block tag, which is defined by the first @ character that begins a line (ignoring leading asterisks, white space, and leading separator /**). It is possible to have a comment with only a tag section and no main description. The main description cannot continue after the tag section begins. The argument to a tag can span multiple lines. There can be any number of tags, and some types of tags can be repeated while others cannot. For example, this @see tag starts the tag section:

/**
 * This sentence holds the main description for this documentation comment.
 * @see java.lang.Object
 */

Block and inline Tags A tag is a special keyword within a documentation comment that the javadoc command processes. There are two kinds of tags: block tags, which appear as an @tag tag (also known as standalone tags), and inline tags, which appear within braces, as an {@tag} tag. To be interpreted, a block tag must appear at the beginning of a line, ignoring leading asterisks, white space, and the separator (/**). This means you can use the @ character elsewhere in the text and it will not be interpreted as the start of a tag. If you want to start a line with the @ character and not have it be interpreted, then use the HTML entity &#064;. Each block tag has associated text, which includes any text following the tag up to, but not including, either the next tag, or the end of the documentation comment. This associated text can span multiple lines. An inline tag is allowed and interpreted anywhere that text is allowed. The following example contains the @deprecated block tag and the {@link} inline tag. See Javadoc Tags.

/**
 * @deprecated  As of JDK 1.1, replaced by {@link #setBounds(int,int,int,int)}
 */

Write Comments in HTML The text must be written in HTML with HTML entities and HTML tags. You can use whichever version of HTML your browser supports. The standard doclet generates HTML 3.2-compliant code elsewhere (outside of the documentation comments) with the inclusion of cascading style sheets and frames. HTML 4.0 is preferred for generated files because of the frame sets.

For example, entities for the less than symbol (<) and the greater than symbol (>) should be written as &lt; and &gt;. Similarly, the ampersand (&) should be written as &amp;. The bold HTML tag <b> is shown in the following example.

/**
 * This is a <b>doc</b> comment.
 * @see java.lang.Object
 */

Leading Asterisks When the javadoc command parses a documentation comment, leading asterisks (*) on each line are discarded, and blanks and tabs that precede the initial asterisks (*) are also discarded. If you omit the leading asterisk on a line, then the leading white space is no longer removed so that you can paste code examples directly into a documentation comment inside a <PRE> tag with its indentation preserved. Spaces are interpreted by browsers more uniformly than tabs. Indentation is relative to the left margin (rather than the separator /** or <PRE> tag).

First Sentence The first sentence of each documentation comment should be a summary sentence that contains a concise but complete description of the declared entity. This sentence ends at the first period that is followed by a blank, tab, or line terminator, or at the first block tag. The javadoc command copies this first sentence to the member summary at the top of the HTML page.

Multiple-Field Declarations The Java platform lets you declare multiple fields in a single statement, but this statement can have only one documentation comment that is copied for all fields. If you want individual documentation comments for each field, then declare each field in a separate statement. For example, the following documentation comment does not make sense written as a single declaration and would be better handled as two declarations:

/**
 * The horizontal and vertical distances of point (x,y)
 */
public int x, y;      // Avoid this

The javadoc command generates the following documentation from the previous code:

public int x

The horizontal and vertical distances of point (x, y).

public int y

The horizontal and vertical distances of point (x, y).

Use of Header Tags When writing documentation comments for members, it is best not to use HTML heading tags such as <H1> and <H2>, because the javadoc command creates an entire structured document, and these structural tags might interfere with the formatting of the generated document. However, you can use these headings in class and package comments to provide your own structure.

  METHOD COMMENT INHERITANCE
The javadoc command allows method comment inheritance in classes and interfaces to fill in missing text or to explicitly inherit method comments. Constructors, fields, and nested classes do not inherit documentation comments.

Note: The source file for an inherited method must be on the path specified by the -sourcepath option for the documentation comment to be available to copy. Neither the class nor its package needs to be passed in on the command line. This contrasts with Release 1.3.n and earlier releases, where the class had to be a documented class.

Fill in Missing Text When a main description, or @return, @param, or @throws tag is missing from a method comment, the javadoc command copies the corresponding main description or tag comment from the method it overrides or implements (if any). See Method Comment Inheritance.

When an @param tag for a particular parameter is missing, the comment for that parameter is copied from the method further up the inheritance hierarchy. When an @throws tag for a particular exception is missing, the @throws tag is copied only when that exception is declared.

This behavior contrasts with Release 1.3 and earlier, where the presence of any main description or tag would prevent all comments from being inherited.

See Javadoc Tags and Options.

Explicit Inheritance Insert the {@inheritDoc} inline tag in a method main description or @return, @param, or @throws tag comment. The corresponding inherited main description or tag comment is copied into that spot.

  CLASS AND INTERFACE INHERITANCE
Comment inheritance occurs in all possible cases of inheritance from classes and interfaces:

•   When a method in a class overrides a method in a superclass

•   When a method in an interface overrides a method in a superinterface

•   When a method in a class implements a method in an interface

In the first two cases, the javadoc command generates the subheading Overrides in the documentation for the overriding method. A link to the method being overridden is included, whether or not the comment is inherited.

In the third case, when a method in a specified class implements a method in an interface, the javadoc command generates the subheading Specified by in the documentation for the overriding method. A link to the method being implemented is included, whether or not the comment is inherited.

  METHOD COMMENTS ALGORITHM
If a method does not have a documentation comment, or has an {@inheritDoc} tag, then the javadoc command uses the following algorithm to search for an applicable comment. The algorithm is designed to find the most specific applicable documentation comment, and to give preference to interfaces over superclasses:

1.  Look in each directly implemented (or extended) interface in the order they appear following the word implements (or extends) in the method declaration. Use the first documentation comment found for this method.

2.  If Step 1 failed to find a documentation comment, then recursively apply this entire algorithm to each directly implemented (or extended) interface in the same order they were examined in Step 1.

3.  When Step 2 fails to find a documentation comment and this is a class other than the Object class, but not an interface:

    1.  If the superclass has a documentation comment for this method, then use it.

    2.  If Step 3a failed to find a documentation comment, then recursively apply this entire algorithm to the superclass.

JAVADOC TAGS
The javadoc command parses special tags when they are embedded within a Java documentation comment. The javadoc tags let you autogenerate a complete, well-formatted API from your source code. The tags start with an at sign (@) and are case-sensitive. They must be typed with the uppercase and lowercase letters as shown. A tag must start at the beginning of a line (after any leading spaces and an optional asterisk), or it is treated as text. By convention, tags with the same name are grouped together. For example, put all @see tags together. For more information, see Where Tags Can Be Used.

Tags have the following types:

•   Bock tags: Place block tags only in the tag section that follows the description. Block tags have the form: @tag.

•   Inline tags: Place inline tags anywhere in the main description or in the comments for block tags. Inline tags are enclosed within braces: {@tag}.

For custom tags, see -tag tagname:Xaoptcmf:"taghead". See also Where Tags Can Be Used.

  TAG DESCRIPTIONS

@author name-text
    Introduced in JDK 1.0 Adds an Author entry with the specified name text to the generated documents when the -author option is used. A documentation comment can contain multiple @author tags. You can specify one name per @author tag or multiple names per tag. In the former case, the javadoc command inserts a comma (,) and space between names. In the latter case, the entire text is copied to the generated document without being parsed. Therefore, you can use multiple names per line if you want a localized name separator other than a comma. See @author in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@author

{@code text}
    Introduced in JDK 1.5 Equivalent to <code>{@literal}</code>. Displays text in code font without interpreting the text as HTML markup or nested Javadoc tags. This enables you to use regular angle brackets (< and >) instead of the HTML entities (&lt; and &gt;) in documentation comments, such as in parameter types (<Object>), inequalities (3 < 4), or arrows (<-). For example, the documentation comment text {@code A<B>C} displayed in the generated HTML page unchanged as A<B>C. This means that the <B> is not interpreted as bold and is in code font. If you want the same functionality without the code font, then use the {@literal} tag.

@deprecated deprecated-text
    Introduced in JDK 1.0 Adds a comment indicating that this API should no longer be used (even though it may continue to work). The javadoc command moves deprecated-textahead of the main description, placing it in italics and preceding it with a bold warning: Deprecated. This tag is valid in all documentation comments: overview, package, class, interface, constructor, method and field. The first sentence of deprecated text should tell the user when the API was deprecated and what to use as a replacement. The javadoc command copies the first sentence to the summary section and index. Subsequent sentences can also explain why it was deprecated. You should include an {@link} tag (for Javadoc 1.2 or later) that points to the replacement API. Use the @deprecated annotation tag to deprecate a program element. See How and When to Deprecate APIs at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/deprecation/deprecation.html See also @deprecated in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@deprecated

{@docRoot}
    Introduced in JDK 1.3 Represents the relative path to the generated document's (destination) root directory from any generated page. This tag is useful when you want to include a file, such as a copyright page or company logo, that you want to reference from all generated pages. Linking to the copyright page from the bottom of each page is common. This {@docRoot} tag can be used both on the command line and in a documentation comment. This tag is valid in all documentation comments: overview, package, class, interface, constructor, method and field, and includes the text portion of any tag (such as the @return, @param and @deprecated tags).

    •   On the command line, where the header, footer, or bottom are defined: javadoc -bottom '<a href="{@docRoot}/copyright.html">Copyright</a>'. When you use the {@docRoot} tag this way in a make file, some makefile programs require a special way to escape for the brace {} characters. For example, the Inprise MAKE version 5.2 running on Windows requires double braces: {{@docRoot}}. It also requires double (rather than single) quotation marks to enclose arguments to options such as the -bottom option (with the quotation marks around the href argument omitted).

    •   In a documentation comment:

        /**
         * See the <a href="{@docRoot}/copyright.html">Copyright</a>.
         */

        This tag is needed because the generated documents are in hierarchical directories, as deep as the number of subpackages. The expression: <a href="{@docRoot}/copyright.html"> resolves to <a href="../../copyright.html"> for java/lang/Object.java and <a href="../../../copyright.html"> for java/lang/ref/Reference.java.

@exception class-name description
    Introduced in JDK 1.0 Identical to the @throws tag. See @throws class-name description.

{@inheritDoc}
    Introduced in JDK 1.4 Inherits (copies) documentation from the nearest inheritable class or implementable interface into the current documentation comment at this tag's location. This enables you to write more general comments higher up the inheritance tree and to write around the copied text. This tag is valid only in these places in a documentation comment:

    •   In the main description block of a method. In this case, the main description is copied from a class or interface up the hierarchy.

    •   In the text arguments of the @return, @param, and @throws tags of a method. In this case, the tag text is copied from the corresponding tag up the hierarchy.
See Method Comment Inheritance for a description of how comments are found in the inheritance hierarchy. Note that if this tag is missing, then the comment is or is not automatically inherited according to rules described in that section.

{@link package.class#member label}
    Introduced in JDK 1.2 Inserts an inline link with a visible text label that points to the documentation for the specified package, class, or member name of a referenced class. This tag is valid in all documentation comments: overview, package, class, interface, constructor, method and field, including the text portion of any tag, such as the @return, @param and @deprecated tags. See @link in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#{@link This tag is similar to the @see tag. Both tags require the same references and accept the same syntax for package.class#member and label. The main difference is that the {@link} tag generates an inline link rather than placing the link in the See Also section. The {@link} tag begins and ends with braces to separate it from the rest of the inline text. If you need to use the right brace (}) inside the label, then use the HTML entity notation &#125;. There is no limit to the number of {@link} tags allowed in a sentence. You can use this tag in the main description part of any documentation comment or in the text portion of any tag, such as the @deprecated, @return or @param tags. For example, here is a comment that refers to the getComponentAt(int, int) method:

    Use the {@link #getComponentAt(int, int) getComponentAt} method.

    From this code, the standard doclet generates the following HTML (assuming it refers to another class in the same package):

    Use the <a href="Component.html#getComponentAt(int, int)">getComponentAt</a> method.

    The previous line appears on the web page as:

    Use the getComponentAt method.

{@linkplain package.class#member label}
    Introduced in JDK 1.4 Behaves the same as the {@link} tag, except the link label is displayed in plain text rather than code font. Useful when the label is plain text. For example, Refer to {@linkplain add() the overridden method}. displays as: Refer to the overridden method.

{@literal text}
    Introduced in JDK 1.5 Displays text without interpreting the text as HTML markup or nested Javadoc tags. This enables you to use angle brackets (< and >) instead of the HTML entities (&lt; and &gt;) in documentation comments, such as in parameter types (<Object>), inequalities (3 < 4), or arrows (<-). For example, the documentation comment text {@literal A<B>C} displays unchanged in the generated HTML page in your browser, as A<B>C. The <B> is not interpreted as bold (and it is not in code font). If you want the same functionality with the text in code font, then use the {@code} tag.

@param parameter-name description
    Introduced in JDK 1.0 Adds a parameter with the specified parameter-name followed by the specified description to the Parameters section. When writing the documentation comment, you can continue the description onto multiple lines. This tag is valid only in a documentation comment for a method, constructor, or class. See @param in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@param The parameter-name can be the name of a parameter in a method or constructor, or the name of a type parameter of a class, method, or constructor. Use angle brackets around this parameter name to specify the use of a type parameter. Example of a type parameter of a class:

    /**
     * @param <E> Type of element stored in a list
     */
    public interface List<E> extends Collection<E> {
    }

    Example of a type parameter of a method:

    /**
     * @param string  the string to be converted
     * @param type    the type to convert the string to
     * @param <T>     the type of the element
     * @param <V>     the value of the element
     */
    <T, V extends T> V convert(String string, Class<T> type) {
    }

@return description
    Introduced in JDK 1.0 Adds a Returns section with the description text. This text should describe the return type and permissible range of values. This tag is valid only in a documentation comment for a method. See @return in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@return

@see reference
    Introduced in JDK 1.0 Adds a See Also heading with a link or text entry that points to a reference. A documentation comment can contain any number of @see tags, which are all grouped under the same heading. The @see tag has three variations. The form is the most common. This tag is valid in any documentation comment: overview, package, class, interface, constructor, method, or field. For inserting an inline link within a sentence to a package, class, or member, see {@link}. Form 1. The @see string tag form adds a text entry for string. No link is generated. The string is a book or other reference to information not available by URL. The javadoc command distinguishes this from the previous cases by searching for a double quotation mark (") as the first character. For example, @see "The Java Programming Language" that generates the following text: See Also: "The Java Programming Language" Form 2. The @see <a href="URL#value">label</a> form adds a link as defined by URL#value. The URL#value parameter is a relative or absolute URL. The javadoc command distinguishes this from other cases by searching for a less-than symbol (<) as the first character. For example, @see <a href="spec.html#section">Java Spec</a> generates the following link: See Also: Java Spec Form 3. The @see package.class#member label form adds a link with a visible text label that points to the documentation for the specified name in the Java Language that is referenced. The label is optional. If the label is omitted, then the name appears instead as visible text, suitably shortened. Use the -noqualifier option to globally remove the package name from this visible text. Use the label when you want the visible text to be different from the autogenerated visible text. See How a Name Appears. In Java SE 1.2 only, the name but not the label automatically appears in <code> HTML tags. Starting with Java SE 1.2.2, the <code> tag is always included around the visible text, whether or not a label is used.

    •   package.class#member is any valid program element name that is referenced, such as a package, class, interface, constructor, method or field name, except that the character ahead of the member name should be a number sign (#). The class represents any top-level or nested class or interface. The member represents any constructor, method, or field (not a nested class or interface). If this name is in the documented classes, then the javadoc command create a link to it. To create links to external referenced classes, use the -link option. Use either of the other two @see tag forms to refer to the documentation of a name that does not belong to a referenced class. See Specify a Name. Note: External referenced classes are classes that are not passed into the javadoc command on the command line. Links in the generated documentation to external referenced classes are called external references or external links. For example, if you run the javadoc command on only the java.awt package, then any class in java.lang, such as Object, is an external referenced class. Use the -link and -linkoffline options to link to external referenced classes. The source comments of external referenced classes are not available to the javadoc command run.

    •   label is optional text that is visible as the link label. The label can contain white space. If label is omitted, then package.class.member appears, suitably shortened relative to the current class and package. See How a Name Appears.

    •   A space is the delimiter between package.class#member and label. A space inside parentheses does not indicate the start of a label, so spaces can be used between parameters in a method.
In the following example, an @see tag (in the Character class) refers to the equals method in the String class. The tag includes both arguments: the name String#equals(Object) and the label equals.

/**
 * @see String#equals(Object) equals
 */

The standard doclet produces HTML that is similar to:

<dl>
<dt><b>See Also:</b>
<dd><a href="../../java/lang/String#equals(java.lang.Object)"><code>equals<code></a>
</dl>

The previous code looks similar to the following in a browser, where the label is the visible link text: See Also: equals

Specify a Name This package.class#member name can be either fully qualified, such as java.lang.String#toUpperCase() or not, such as String#toUpperCase() or #toUpperCase(). If the name is less than fully qualified, then the javadoc command uses the standard Java compiler search order to find it. See Search Order for the @see Tag. The name can contain white space within parentheses, such as between method arguments.The advantage to providing shorter, partially qualified names is that they are shorter to type and there is less clutter in the source code. The following listing shows the different forms of the name, where Class can be a class or interface; Type can be a class, interface, array, or primitive; and method can be a method or constructor.

Typical forms for @see package.class#member
Referencing a member of the current class
@see #field
@see #method(Type, Type,...)
@see #method(Type argname, Type argname,...)
@see #constructor(Type, Type,...)
@see #constructor(Type argname, Type argname,...)

Referencing another class in the current or imported packages
@see Class#field
@see Class#method(Type, Type,...)
@see Class#method(Type argname, Type argname,...)
@see Class#constructor(Type, Type,...)
@see Class#constructor(Type argname, Type argname,...)
@see Class.NestedClass
@see Class

Referencing an element in another package (fully qualified)
@see package.Class#field
@see package.Class#method(Type, Type,...)
@see package.Class#method(Type argname, Type argname,...)
@see package.Class#constructor(Type, Type,...)
@see package.Class#constructor(Type argname, Type argname,...)
@see package.Class.NestedClass
@see package.Class
@see package

Notes about the previous listing:

•   The first set of forms with no class or package causes the javadoc command to search only through the current class hierarchy. It finds a member of the current class or interface, one of its superclasses or superinterfaces, or one of its enclosing classes or interfaces (search Items 1–3). It does not search the rest of the current package or other packages (search Items 4–5). See Search Order for the @see Tag.

•   If any method or constructor is entered as a name with no parentheses, such as getValue, and if there is no field with the same name, then the javadoc command still creates a link to the method. If this method is overloaded, then the javadoc command links to the first method its search encounters, which is unspecified.

•   Nested classes must be specified as outer.inner, not simply inner, for all forms.

•   As stated, the number sign (#), rather than a dot (.) separates a member from its class. This enables the javadoc command to resolve ambiguities, because the dot also separates classes, nested classes, packages, and subpackages. However, the javadoc command properly parses a dot when there is no ambiguity, but prints a warning to alert you.

Search Order for the @see Tag The javadoc command processes an @see tag that appears in a source file, package file, or overview file. In the latter two files, you must fully qualify the name you supply with the @see tag. In a source file, you can specify a name that is fully qualified or partially qualified.

The following is the search order for the @see tag.

1.  The current class or interface.

2.  Any enclosing classes and interfaces searching the closest first.

3.  Any superclasses and superinterfaces, searching the closest first.

4.  The current package.

5.  Any imported packages, classes, and interfaces, searching in the order of the import statement.

The javadoc command continues to search recursively through Items 1-3 for each class it encounters until it finds a match. That is, after it searches through the current class and its enclosing class E, it searches through the superclasses of E before the enclosing classes of E. In Items 4 and 5, the javadoc command does not search classes or interfaces within a package in any specified order (that order depends on the particular compiler). In Item 5, the javadoc command searches in java.lang because that is imported by all programs.

When the javadoc command encounters an @see tag in a source file that is not fully qualified, it searches for the specified name in the same order as the Java compiler would, except the javadoc command does not detect certain name space ambiguities because it assumes the source code is free of these errors. This search order is formally defined in the Java Language Specification. The javadoc command searches for that name through all related and imported classes and packages. In particular, it searches in this order:

1.  The current class or interface.

2.  Any enclosing classes and interfaces, searching the closest first.

3.  Any superclasses and superinterfaces, searching the closest first.

4.  The current package.

5.  Any imported packages, classes, and interfaces, searching in the order of the import statements.

The javadoc command does not necessarily look in subclasses, nor will it look in other packages even when their documentation is being generated in the same run. For example, if the @see tag is in the java.awt.event.KeyEvent class and refers to a name in the java.awt package, then the javadoc command does not look in that package unless that class imports it.

How a Name Appears If label is omitted, then package.class.member appears. In general, it is suitably shortened relative to the current class and package. Shortened means the javadoc command displays only the minimum name necessary. For example, if the String.toUpperCase() method contains references to a member of the same class and to a member of a different class, then the class name is displayed only in the latter case, as shown in the following listing. Use the -noqualifier option to globally remove the package names.

Type of reference: The @see tag refers to a member of the same class, same package
Example in: @see String#toLowerCase()
Appears as: toLowerCase() - omits the package and class names

Type of reference: The @see tag refers to a member of a different class, same package
Example in: @see Character#toLowerCase(char)
Appears as: Character.toLowerCase(char) - omits the package name, includes the class name

Type of reference: The @see tag refers to a member of a different class, different package
Example in: @see java.io.File#exists()
Appears as: java.io.File.exists() - includes the package and class names

Examples of the @see Tag The comment to the right shows how the name appears when the @see tag is in a class in another package, such as java.applet.Applet. See @see in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@see

                                            See also:
@see java.lang.String                   //  String
@see java.lang.String The String class  //  The String class
@see String                             //  String
@see String#equals(Object)              //  String.equals(Object)
@see String#equals                      //  String.equals(java.lang.Object)
@see java.lang.Object#wait(long)        //  java.lang.Object.wait(long)
@see Character#MAX_RADIX                //  Character.MAX_RADIX
@see <a href="spec.html">Java Spec</a>  //  Java Spec
@see "The Java Programming Language"    //  "The Java Programming Language"

Note: You can extend the @see tag to link to classes not being documented with the -link option.

@serial field-description | include | exclude
    Introduced in JDK 1.2 Used in the documentation comment for a default serializable field. See Documenting Serializable Fields and Data for a Class at http://docs.oracle.com/javase/8/docs/platform/serialization/spec/serial-arch.html#5251 See also Oracle’s Criteria for Including Classes in the Serialized Form Specification at http://www.oracle.com/technetwork/java/javase/documentation/serialized-criteria-137781.html An optional field-description should explain the meaning of the field and list the acceptable values. When needed, the description can span multiple lines. The standard doclet adds this information to the serialized form page. See Cross-Reference Pages. If a serializable field was added to a class after the class was made serializable, then a statement should be added to its main description to identify at which version it was added. The include and exclude arguments identify whether a class or package should be included or excluded from the serialized form page. They work as follows:

    •   A public or protected class that implements Serializable is included unless that class (or its package) is marked with the @serial exclude tag.

    •   A private or package-private class that implements Serializable is excluded unless that class (or its package) is marked with the @serial include tag.
For example, the javax.swing package is marked with the @serialexclude tag in package.html or package-info.java. The public class java.security.BasicPermission is marked with the @serial exclude tag. The package-private class java.util.PropertyPermissionCollection is marked with the @serial include tag. The @serial tag at the class level overrides the @serial tag at the package level.

@serialData data-description
    Introduced in JDK 1.2 Uses the data description value to document the types and order of data in the serialized form. This data includes the optional data written by the writeObject method and all data (including base classes) written by the Externalizable.writeExternal method. The @serialData tag can be used in the documentation comment for the writeObject, readObject, writeExternal, readExternal, writeReplace, and readResolve methods.

@serialField field-namefield-typefield-description
    Introduced in JDK 1.2 Documents an ObjectStreamField component of the serialPersistentFields member of a Serializable class. Use one @serialField tag for each ObjectStreamField component.

@since since-text
    Introduced in JDK 1.1 Adds a Since heading with the specified since-text value to the generated documentation. The text has no special internal structure. This tag is valid in any documentation comment: overview, package, class, interface, constructor, method, or field. This tag means that this change or feature has existed since the software release specified by the since-text value, for example: @since 1.5. For Java platform source code, the @since tag indicates the version of the Java platform API specification, which is not necessarily when the source code was added to the reference implementation. Multiple @since tags are allowed and are treated like multiple @author tags. You could use multiple tags when the program element is used by more than one API.

@throws class-namedescription
    Introduced in JDK 1.2 Behaves the same as the @exception tag. See @throws in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@exception The @throws tag adds a Throws subheading to the generated documentation, with the class-name and description text. The class-name is the name of the exception that might be thrown by the method. This tag is valid only in the documentation comment for a method or constructor. If this class is not fully specified, then the javadoc command uses the search order to look up this class. Multiple @throws tags can be used in a specified documentation comment for the same or different exceptions. See Search Order for the @see Tag. To ensure that all checked exceptions are documented, when an @throws tag does not exist for an exception in the throws clause, the javadoc command adds that exception to the HTML output (with no description) as though it were documented with the @throws tag. The @throws documentation is copied from an overridden method to a subclass only when the exception is explicitly declared in the overridden method. The same is true for copying from an interface method to an implementing method. You can use the {@inheritDoc} tag to force the @throws tag to inherit documentation.

{@value package.class#field}
    Introduced in JDK 1.4 Displays constant values. When the {@value} tag is used without an argument in the documentation comment of a static field, it displays the value of that constant:

    /**
     * The value of this constant is {@value}.
     */
    public static final String SCRIPT_START = "<script>"

    When used with the argument package.class#field in any documentation comment, he {@value} tag displays the value of the specified constant:

    /**
     * Evaluates the script starting with {@value #SCRIPT_START}.
     */
    public String evalScript(String script) {}

    The argument package.class#field takes a form similar to that of the @see tag argument, except that the member must be a static field. The values of these constants are also displayed in Constant Field Values at http://docs.oracle.com/javase/8/docs/api/constant-values.html

@version version-text
    Introduced in JDK 1.0 Adds a Version subheading with the specified version-text value to the generated documents when the -version option is used. This tag is intended to hold the current release number of the software that this code is part of, as opposed to the@since tag, which holds the release number where this code was introduced. The version-text value has no special internal structure. See @version in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#@version A documentation comment can contain multiple @version tags. When it makes sense, you can specify one release number per @version tag or multiple release numbers per tag. In the former case, the javadoc command inserts a comma (,) and a space between the names. In the latter case, the entire text is copied to the generated document without being parsed. Therefore, you can use multiple names per line when you want a localized name separator other than a comma.

WHERE TAGS CAN BE USED
The following sections describe where tags can be used. Note that the following tags can be used in all documentation comments: @see, @since, @deprecated, {@link}, {@linkplain}, and {@docroot}.

  OVERVIEW TAGS
Overview tags are tags that can appear in the documentation comment for the overview page (which resides in the source file typically named overview.html). Similar to any other documentation comments, these tags must appear after the main description

Note: The {@link} tag has a bug in overview documents in Java SE 1.2. The text appears correctly but has no link. The {@docRoot} tag does not currently work in overview documents.

The overview tags are the following:

@see reference || @since since-text || @serialField field-name field-type field-description || @author name-text || @version version-text || {@link package.class#member label} || {@linkplain package.class#member label} || {@docRoot} ||

  PACKAGE TAGS
Package tags are tags that can appear in the documentation comment for a package, that resides in the source file named package.html or package-info.java. The @serial tag can only be used here with the include or exclude argument.

The package tags are the following:

@see reference || @since since-text || @serial field-description | include | exclude || @author name-text || @version version-text || {@linkplain package.class#member label} || {@linkplain package.class#member label} || {@docRoot} ||

  CLASS AND INTERFACE TAGS
The following are tags that can appear in the documentation comment for a class or interface. The @serial tag can only be used within the documentation for a class or interface with an include or exclude argument.

@see reference || @since since-text || @deprecated deprecated-text || @serial field-description | include | exclude || @author name-text || @version version-text || {@link package.class#member label} || {@linkplain package.class#member label} || {@docRoot} ||

Class comment example:

/**
 * A class representing a window on the screen.
 * For example:
 * <pre>
 *    Window win = new Window(parent);
 *    win.show();
 * </pre>
 *
 * @author  Sami Shaio
 * @version 1.13, 06/08/06
 * @see     java.awt.BaseWindow
 * @see     java.awt.Button
 */
class Window extends BaseWindow {
   ...
}

  FIELD TAGS
These tags can appear in fields:

@see reference || @since since-text || @deprecated deprecated-text || @serial field-description | include | exclude || @serialField field-name field-type field-description || {@link package.class#member label} || {@linkplain package.class#member label} || {@docRoot} || {@value package.class#field}

Field comment example:

    /**
     * The X-coordinate of the component.
     *
     * @see #getLocation()
     */
    int x = 1263732;

  CONSTRUCTOR AND METHOD TAGS
The following tags can appear in the documentation comment for a constructor or a method, except for the @return tag, which cannot appear in a constructor, and the {@inheritDoc} tag, which has restrictions.

@see reference || @since since-text || @deprecated deprecated-text || @param parameter-name description || @return description || @throws class-name description || @exception class-name description || @serialData data-description || {@link package.class#member label} || {@linkplain package.class#member label} || {@inheritDoc} || {@docRoot}

Note: The @serialData tag can only be used in the documentation comment for the writeObject, readObject, writeExternal, readExternal, writeReplace, and readResolve methods.

Method comment example:

/**
     * Returns the character at the specified index. An index
     * ranges from <code>0</code> to <code>length() - 1</code>
     *
     * @param     index the index of the desired character.
     * @return    the desired character.
     * @exception StringIndexOutOfRangeException
     *              if the index is not in the range <code>0</code>
     *              to <code>length()-1</code>
     * @see       java.lang.Character#charValue()
     */
    public char charAt(int index) {
       ...
    }

OPTIONS
The javadoc command uses doclets to determine its output. The javadoc command uses the default standard doclet unless a custom doclet is specified with the -doclet option. The javadoc command provides a set of command-line options that can be used with any doclet. These options are described in Javadoc Options. The standard doclet provides an additional set of command-line options that are described in Standard Doclet Options. All option names are not case-sensitive, but their arguments are case-sensitive.

•   See also Javadoc Options

•   See also Standard Doclet Options

The options are:

-1.1 || -author || -bootclasspath classpathlist || -bottom text || -breakiterator || -charset name || -classpath classpathlist || -d directory || -docencoding name || -docfilesubdirs || -doclet class || -docletpath classpathlist || -doctitle title || -encoding || -exclude packagename1:packagename2:... || -excludedocfilessubdir name1:name2 || -extdirs dirist || -footer footer || -group groupheading packagepattern:packagepattern || -header header || -help || -helpfile path\filename || -Jflag || -javafx ||-keywords || -link extdocURL || -linkoffline extdocURL packagelistLoc || -linksource || -locale language_country_variant || -nocomment || -nodeprecated || -nodeprecatedlist || -nohelp || -noindex || -nonavbar || -noqualifier all | packagename1:packagename2... || -nosince || -notimestamp || -notree || -overview path/filename || -package || -private || -protected || -public || -quiet || -serialwarn || -source release || -sourcepath sourcepathlist || -sourcetab tablength || -splitindex || -stylesheet path/filename || -subpackages package1:package2:... || -tag tagname:Xaoptcmf:"taghead" || -taglet class || -tagletpath tagletpathlist || -title title || -top || -use || -verbose || -version || -windowtitle title

The following options are the core Javadoc options that are available to all doclets. The standard doclet provides the rest of the doclets: -bootclasspath, -breakiterator, -classpath, -doclet, -docletpath, -encoding, -exclude, -extdirs, -help, -locale, -overview, -package, -private, -protected, -public, -quiet, -source, -sourcepath, -subpackages, and -verbose.

  JAVADOC OPTIONS

-overview path/filename
    Specifies that the javadoc command should retrieve the text for the overview documentation from the source file specified by the path/filenameand place it on the Overview page (overview-summary.html). The path/filenameis relative to the current directory. While you can use any name you want for the filename value and place it anywhere you want for the path, it is typical to name it overview.html and place it in the source tree at the directory that contains the topmost package directories. In this location, no path is needed when documenting packages, because the -sourcepath option points to this file. For example, if the source tree for the java.lang package is /src/classes/java/lang/, then you could place the overview file at /src/classes/overview.html See Real-World Examples. For information about the file specified by path/filename,see Overview Comment Files. The overview page is created only when you pass two or more package names to the javadoc command. For a further explanation, see HTML Frames. The title on the overview page is set by -doctitle.

-Xdoclint:(all|none|[-]<group>)
    Reports warnings for bad references, lack of accessibility and missing Javadoc comments, and reports errors for invalid Javadoc syntax and missing HTML tags. This option enables the javadoc command to check for all documentation comments included in the generated output. As always, you can select which items to include in the generated output with the standard options -public, -protected, -package and -private. When the -Xdoclint is enabled, it reports issues with messages similar to the javac command. The javadoc command prints a message, a copy of the source line, and a caret pointing at the exact position where the error was detected. Messages may be either warnings or errors, depending on their severity and the likelihood to cause an error if the generated documentation were run through a validator. For example, bad references or missing Javadoc comments do not cause the javadoc command to generate invalid HTML, so these issues are reported as warnings. Syntax errors or missing HTML end tags cause the javadoc command to generate invalid output, so these issues are reported as errors. By default, the -Xdoclint option is enabled. Disable it with the option -Xdoclint:none. Change what the -Xdoclint option reports with the following options:

    •   -Xdoclint none : disable the -Xdoclint option

    •   -Xdoclintgroup : enable group checks

    •   -Xdoclint all : enable all groups of checks

    •   -Xdoclint all,-group : enable all except group checks
The variable group has one of the following values:

    •   accessibility : Checks for the issues to be detected by an accessibility checker (for example, no caption or summary attributes specified in a <table> tag).

    •   html : Detects high-level HTML issues, like putting block elements inside inline elements, or not closing elements that require an end tag. The rules are derived from theHTML 4.01 Specification. This type of check enables the javadoc command to detect HTML issues that many browsers might accept.

    •   missing : Checks for missing Javadoc comments or tags (for example, a missing comment or class, or a missing @return tag or similar tag on a method).

    •   reference : Checks for issues relating to the references to Java API elements from Javadoc tags (for example, item not found in @see , or a bad name after @param).

    •   syntax : Checks for low level issues like unescaped angle brackets (< and >) and ampersands (&) and invalid Javadoc tags.
You can specify the -Xdoclint option multiple times to enable the option to check errors and warnings in multiple categories. Alternatively, you can specify multiple error and warning categories by using the preceding options. For example, use either of the following commands to check for the HTML, syntax, and accessibility issues in the file filename.

javadoc -Xdoclint:html -Xdoclint:syntax -Xdoclint:accessibility filename
javadoc -Xdoclint:html,syntax,accessibility filename

Note: The javadoc command does not guarantee the completeness of these checks. In particular, it is not a full HTML compliance checker. The goal of the -Xdoclint option is to enable the javadoc command to report majority of common errors. The javadoc command does not attempt to fix invalid input, it just reports it.

-public
    Shows only public classes and members.

-protected
    Shows only protected and public classes and members. This is the default.

-package
    Shows only package, protected, and public classes and members.

-private
    Shows all classes and members.

-help
    Displays the online help, which lists all of the javadoc and doclet command-line options.

-doclet class
    Specifies the class file that starts the doclet used in generating the documentation. Use the fully qualified name. This doclet defines the content and formats the output. If the -doclet option is not used, then the javadoc command uses the standard doclet for generating the default HTML format. This class must contain the start(Root) method. The path to this starting class is defined by the -docletpath option. See Doclet Overview at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/doclet/overview.html

-docletpath classpathlist
    Specifies the path to the doclet starting class file (specified with the -doclet option) and any JAR files it depends on. If the starting class file is in a JAR file, then this option specifies the path to that JAR file. You can specify an absolute path or a path relative to the current directory. If classpathlist contains multiple paths or JAR files, then they should be separated with a colon (:) on Oracle Solaris and a semi-colon (;) on Windows. This option is not necessary when the doclet starting class is already in the search path. See Doclet Overview at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/doclet/overview.html

-1.1
    Removed from Javadoc 1.4 with no replacement. This option created documentation with the appearance and functionality of documentation generated by Javadoc 1.1 (it never supported nested classes). If you need this option, then use Javadoc 1.2 or 1.3 instead.

-source release
    Specifies the release of source code accepted. The following values for the release parameter are allowed. Use the value of release that corresponds to the value used when you compile code with the javac command.

    •   Release Value: 1.5. The javadoc command accepts code containing generics and other language features introduced in JDK 1.5. The compiler defaults to the 1.5 behavior when the -source option is not used.

    •   Release Value: 1.4. The javadoc command accepts code containing assertions, which were introduced in JDK 1.4.

    •   Release Value: 1.3. The javadoc command does not support assertions, generics, or other language features introduced after JDK 1.3.

-sourcepath sourcepathlist
    Specifies the search paths for finding source files when passing package names or the -subpackages option into the javadoc command. Separate multiple paths with a colon (:). The javadoc command searches all subdirectories of the specified paths. Note that this option is not only used to locate the source files being documented, but also to find source files that are not being documented, but whose comments are inherited by the source files being documented. You can use the -sourcepath option only when passing package names into the javadoc command. This will not locate source files passed into the javadoc command. To locate source files, change to that directory or include the path ahead of each file, as shown at Document One or More Classes. If you omit -sourcepath, then the javadoc command uses the class path to find the source files (see -classpath). The default -sourcepath is the value of class path. If -classpath is omitted and you pass package names into the javadoc command, then the javadoc command searches in the current directory and subdirectories for the source files. Set sourcepathlist to the root directory of the source tree for the package you are documenting. For example, suppose you want to document a package called com.mypackage, whose source files are located at:/home/user/src/com/mypackage/*.java. Specify the sourcepath to /home/user/src, the directory that contains com\mypackage, and then supply the package name, as follows:

    javadoc -sourcepath /home/user/src/ com.mypackage

    Notice that if you concatenate the value of sourcepath and the package name together and change the dot to a slash (/), then you have the full path to the package: /home/user/src/com/mypackage To point to two source paths:

    javadoc -sourcepath /home/user1/src:/home/user2/src com.mypackage

-classpath classpathlist
    Specifies the paths where the javadoc command searches for referenced classes These are the documented classes plus any classes referenced by those classes. Separate multiple paths with a colon (:). The javadoc command searches all subdirectories of the specified paths. Follow the instructions in the class path documentation for specifying the classpathlist value. If you omit -sourcepath, then the javadoc command uses -classpath to find the source files and class files (for backward compatibility). If you want to search for source and class files in separate paths, then use both -sourcepath and -classpath. For example, if you want to document com.mypackage, whose source files reside in the directory /home/user/src/com/mypackage, and if this package relies on a library in /home/user/lib, then you would use the following command:

    javadoc -sourcepath /home/user/lib -classpath /home/user/src com.mypackage

    Similar to other tools, if you do not specify -classpath, then the javadoc command uses the CLASSPATH environment variable when it is set. If both are not set, then the javadoc command searches for classes from the current directory. For an in-depth description of how the javadoc command uses -classpath to find user classes as it relates to extension classes and bootstrap classes, see How Classes Are Found at http://docs.oracle.com/javase/8/docs/technotes/tools/findingclasses.html A class path element that contains a base name of * is considered equivalent to specifying a list of all the files in the directory with the extension .jar or .JAR. For example, if directory mydir contains a.jar and b.JAR, then the class path element foo/* is expanded to a A.jar:b.JAR, except that the order of JAR files is unspecified. All JAR files in the specified directory including hidden files are included in the list. A class path entry that consists of * expands to a list of all the jar files in the current directory. The CLASSPATH environment variable is similarly expanded. Any class path wildcard expansion occurs before the Java Virtual Machine (JVM) starts. No Java program ever sees unexpanded wild cards except by querying the environment, for example, by calling System.getenv("CLASSPATH").

-subpackages package1:package2:...
    Generates documentation from source files in the specified packages and recursively in their subpackages. This option is useful when adding new subpackages to the source code because they are automatically included. Each package argument is any top-level subpackage (such as java) or fully qualified package (such as javax.swing) that does not need to contain source files. Arguments are separated by colons on all operating systems. Wild cards are not allowed. Use -sourcepath to specify where to find the packages. This option does not process source files that are in the source tree but do not belong to the packages. See Process Source Files. For example, the following command generates documentation for packages named java and javax.swing and all of their subpackages.

    javadoc -d docs -sourcepath /home/user/src  -subpackages java:javax.swing

-exclude packagename1:packagename2:...
    Unconditionally excludes the specified packages and their subpackages from the list formed by -subpackages. It excludes those packages even when they would otherwise be included by some earlier or later -subpackages option. The following example would include java.io, java.util, and java.math (among others), but would exclude packages rooted at java.net and java.lang. Notice that this example excludes java.lang.ref, which is a subpackage of java.lang.

    javadoc -sourcepath /home/user/src -subpackages java -exclude
        java.net:java.lang

-bootclasspath classpathlist
    Specifies the paths where the boot classes reside. These are typically the Java platform classes. The bootclasspath is part of the search path the javadoc command uses to look up source and class files. For more information, see How Classes Are Found at http://docs.oracle.com/javase/8/docs/technotes/tools/findingclasses.html Separate directories in the classpathlist parameters with semicolons (;) for Windows and colons (:) for Oracle Solaris.

-extdirs dirist
    Specifies the directories where extension classes reside. These are any classes that use the Java Extension mechanism. The extdirs option is part of the search path the javadoc command uses to look up source and class files. See the -classpath option for more information. Separate directories in dirlist with semicolons (;) for Windows and colons (:) for Oracle Solaris.

-verbose
    Provides more detailed messages while the javadoc command runs. Without the verbose option, messages appear for loading the source files, generating the documentation (one message per source file), and sorting. The verbose option causes the printing of additional messages that specify the number of milliseconds to parse each Java source file.

-quiet
    Shuts off messages so that only the warnings and errors appear to make them easier to view. It also suppresses the version string.

-breakiterator
    Uses the internationalized sentence boundary of java.text.BreakIterator to determine the end of the first sentence in the main description of a package, class, or member for English. All other locales already use the BreakIterator class, rather than an English language, locale-specific algorithm. The first sentence is copied to the package, class, or member summary and to the alphabetic index. From JDK 1.2 and later, the BreakIterator class is used to determine the end of a sentence for all languages except for English. Therefore, the -breakiterator option has no effect except for English from 1.2 and later. English has its own default algorithm:

    •   English default sentence-break algorithm. Stops at a period followed by a space or an HTML block tag, such as <P>.

    •   Breakiterator sentence-break algorithm. Stops at a period, question mark, or exclamation point followed by a space when the next word starts with a capital letter. This is meant to handle most abbreviations (such as "The serial no. is valid", but will not handle "Mr. Smith"). The -breakiterator option does not stop at HTML tags or sentences that begin with numbers or symbols. The algorithm stops at the last period in ../filename, even when embedded in an HTML tag.
In Java SE 1.5 the -breakiterator option warning messages are removed, and the default sentence-break algorithm is unchanged. If you have not modified your source code to eliminate the -breakiterator option warnings in Java SE 1.4.x, then you do not have to do anything. The warnings go away starting with Java SE 1.5.0.

-locale language_country_variant
    Specifies the locale that the javadoc command uses when it generates documentation. The argument is the name of the locale, as described in java.util.Locale documentation, such as en_US (English, United States) or en_US_WIN (Windows variant). Note: The -locale option must be placed ahead (to the left) of any options provided by the standard doclet or any other doclet. Otherwise, the navigation bars appear in English. This is the only command-line option that depends on order. See Standard Doclet Options. Specifying a locale causes the javadoc command to choose the resource files of that locale for messages such as strings in the navigation bar, headings for lists and tables, help file contents, comments in the stylesheet.css file, and so on. It also specifies the sorting order for lists sorted alphabetically, and the sentence separator to determine the end of the first sentence. The -locale option does not determine the locale of the documentation comment text specified in the source files of the documented classes.

-encoding
    Specifies the encoding name of the source files, such as EUCJIS/SJIS. If this option is not specified, then the platform default converter is used. See also the-docencoding name and -charset name options.

-Jflag
    Passes flag directly to the Java Runtime Environment (JRE) that runs the javadoc command. For example, if you must ensure that the system sets aside 32 MB of memory in which to process the generated documentation, then you would call the -Xmx option as follows: javadoc -J-Xmx32m -J-Xms32m com.mypackage. Be aware that -Xms is optional because it only sets the size of initial memory, which is useful when you know the minimum amount of memory required. There is no space between the J and the flag. Use the -version option to find out what version of the javadoc command you are using. The version number of the standard doclet appears in its output stream. See Running the Javadoc Command.

    javadoc -J-version
    java version "1.7.0_09"
    Java(TM) SE Runtime Environment (build 1.7.0_09-b05)
    Java HotSpot(TM) 64-Bit Server VM (build 23.5-b02, mixed mode)

-javafx
    Generates HTML documentation using the JavaFX extensions to the standard doclet. The generated documentation includes a Property Summary section in addition to the other summary sections generated by the standard Java doclet. The listed properties are linked to the sections for the getter and setter methods of each property. If there are no documentation comments written explicitly for getter and setter methods, the documentation comments from the property method are automatically copied to the generated documentation for these methods. This option also adds a new @defaultValue tag that allows documenting the default value for a property. Example:

    javadoc -javafx MyClass.java -d testdir

  STANDARD DOCLET OPTIONS

-d directory
    Specifies the destination directory where the javadoc command saves the generated HTML files. If you omit the -d option, then the files are saved to the current directory. The directory value can be absolute or relative to the current working directory. As of Java SE 1.4, the destination directory is automatically created when the javadoc command runs. For example, the following command generates the documentation for the package com.mypackage and saves the results in the /user/doc/ directory: javadoc -d/user/doc/com.mypackage.

-use
    Includes one Use page for each documented class and package. The page describes what packages, classes, methods, constructors and fields use any API of the specified class or package. Given class C, things that use class C would include subclasses of C, fields declared as C, methods that return C, and methods and constructors with parameters of type C. For example, you can look at the Use page for the String type. Because the getName method in the java.awt.Font class returns type String, the getName method uses String and so the getName method appears on the Use page for String.This documents only uses of the API, not the implementation. When a method uses String in its implementation, but does not take a string as an argument or return a string, that is not considered a use of String.To access the generated Use page, go to the class or package and click the Use link in the navigation bar.

-version
    Includes the @version text in the generated docs. This text is omitted by default. To find out what version of the javadoc command you are using, use the -J-version option.

-author
    Includes the @author text in the generated docs.

-splitindex
    Splits the index file into multiple files, alphabetically, one file per letter, plus a file for any index entries that start with non-alphabetical symbols.

-windowtitle title
    Specifies the title to be placed in the HTML <title> tag. The text specified in the title tag appears in the window title and in any browser bookmarks (favorite places) that someone creates for this page. This title should not contain any HTML tags because the browser does not interpret them correctly. Use escape characters on any internal quotation marks within the title tag. If the -windowtitle option is omitted, then the javadoc command uses the value of the -doctitle option for the -windowtitle option. For example, javadoc -windowtitle "Java SE Platform" com.mypackage.

-doctitle title
    Specifies the title to place near the top of the overview summary file. The text specified in the title tag is placed as a centered, level-one heading directly beneath the top navigation bar. The title tag can contain HTML tags and white space, but when it does, you must enclose the title in quotation marks. Internal quotation marks within the title tag must be escaped. For example, javadoc -header "<b>Java Platform </b><br>v1.4" com.mypackage.

-title title
    No longer exists. It existed only in Beta releases of Javadoc 1.2. It was renamed to -doctitle. This option was renamed to make it clear that it defines the document title, rather than the window title.

-header header
    Specifies the header text to be placed at the top of each output file. The header is placed to the right of the upper navigation bar. The header can contain HTML tags and white space, but when it does, the header must be enclosed in quotation marks. Use escape characters for internal quotation marks within a header. For example, javadoc -header "<b>Java Platform </b><br>v1.4" com.mypackage.

-footer footer
    Specifies the footer text to be placed at the bottom of each output file. The footer value is placed to the right of the lower navigation bar. The footer value can contain HTML tags and white space, but when it does, the footer value must be enclosed in quotation marks. Use escape characters for any internal quotation marks within a footer.

-top
    Specifies the text to be placed at the top of each output file.

-bottom text
    Specifies the text to be placed at the bottom of each output file. The text is placed at the bottom of the page, underneath the lower navigation bar. The text can contain HTML tags and white space, but when it does, the text must be enclosed in quotation marks. Use escape characters for any internal quotation marks within text.

-link extdocURL
    Creates links to existing Javadoc-generated documentation of externally referenced classes. The extdocURL argument is the absolute or relative URL of the directory that contains the external Javadoc-generated documentation you want to link to. You can specify multiple -link options in a specified javadoc command run to link to multiple documents. The package-list file must be found in this directory (otherwise, use the -linkoffline option). The javadoc command reads the package names from the package-list file and links to those packages at that URL. When the javadoc command runs, the extdocURL value is copied into the <A HREF> links that are created. Therefore, extdocURL must be the URL to the directory, and not to a file. You can use an absolute link for extdocURL to enable your documents to link to a document on any web site, or you can use a relative link to link only to a relative location. If you use a relative link, then the value you pass in should be the relative path from the destination directory (specified with the -d option) to the directory containing the packages being linked to.When you specify an absolute link, you usually use an HTTP link. However, if you want to link to a file system that has no web server, then you can use a file link. Use a file link only when everyone who wants to access the generated documentation shares the same file system.In all cases, and on all operating systems, use a slash as the separator, whether the URL is absolute or relative, and http: or file: as specified in the URL Memo: Uniform Resource Locators at http://www.ietf.org/rfc/rfc1738.txt

    -link  http://<host>/<directory>/<directory>/.../<name>
    -link file://<host>/<directory>/<directory>/.../<name>
    -link <directory>/<directory>/.../<name>

Differences between the -linkoffline and -link options Use the -link option in the following cases:

•   When you use a relative path to the external API document.

•   When you use an absolute URL to the external API document if your shell lets you open a connection to that URL for reading.

Use the -linkoffline option when you use an absolute URL to the external API document, if your shell does not allow a program to open a connection to that URL for reading. This can occur when you are behind a firewall and the document you want to link to is on the other side.

Example 1 Absolute Link to External Documents

Use the following command if you want to link to the java.lang, java.io and other Java platform packages, shown at http://docs.oracle.com/javase/8/docs/api/index.html

javadoc -link http://docs.oracle.com/javase/8/docs/api/ com.mypackage

The command generates documentation for the package com.mypackage with links to the Java SE packages. The generated documentation contains links to the Object class, for example, in the class trees. Other options, such as the -sourcepath and -d options, are not shown.

Example 2 Relative Link to External Documents

In this example, there are two packages with documents that are generated in different runs of the javadoc command, and those documents are separated by a relative path. The packages are com.apipackage, an API, and com.spipackage, an Service Provide Interface (SPI). You want the documentation to reside in docs/api/com/apipackage and docs/spi/com/spipackage. Assuming that the API package documentation is already generated, and that docs is the current directory, you document the SPI package with links to the API documentation by running: javadoc -d ./spi -link ../api com.spipackage.

Notice the -link option is relative to the destination directory (docs/spi).

Notes The -link option lets you link to classes referenced to by your code, but not documented in the current javadoc command run. For these links to go to valid pages, you must know where those HTML pages are located and specify that location with extdocURL. This allows third-party documentation to link to java.* documentation at http://docs.oracle.com.Omit the -link option when you want the javadoc command to create links only to APIs within the documentation it is generating in the current run. Without the -link option, the javadoc command does not create links to documentation for external references because it does not know whether or where that documentation exists.The -link option can create links in several places in the generated documentation. See Process Source Files. Another use is for cross-links between sets of packages: Execute the javadoc command on one set of packages, then run the javadoc command again on another set of packages, creating links both ways between both sets.

How to Reference a Class For a link to an externally referenced class to appear (and not just its text label), the class must be referenced in the following way. It is not sufficient for it to be referenced in the body of a method. It must be referenced in either an import statement or in a declaration. Here are examples of how the class java.io.File can be referenced:

In any kind of import statement. By wildcard import, import explicitly by name, or automatically import for java.lang.*.

In Java SE 1.3.n and 1.2.n, only an explicit import by name works. A wildcard import statement does not work, nor does the automatic import java.lang.*.

In a declaration: void mymethod(File f) {}

The reference can be in the return type or parameter type of a method, constructor, field, class, or interface, or in an implements, extends, or throws statement.

An important corollary is that when you use the -link option, there can be many links that unintentionally do not appear due to this constraint. The text would appear without being a link. You can detect these by the warnings they emit. The simplest way to properly reference a class and add the link would be to import that class.

Package List The -link option requires that a file named package-list, which is generated by the javadoc command, exists at the URL you specify with the -link option. The package-list file is a simple text file that lists the names of packages documented at that location. In the earlier example, the javadoc command searches for a file named package-list at the specified URL, reads in the package names, and links to those packages at that URL.

For example, the package list for the Java SE API is located at http://docs.oracle.com/javase/8/docs/api/package-list

The package list starts as follows:

java.applet
java.awt
java.awt.color
java.awt.datatransfer
java.awt.dnd
java.awt.event
java.awt.font
and so on ....

When javadoc is run without the -link option and encounters a name that belongs to an externally referenced class, it prints the name with no link. However, when the -link option is used, the javadoc command searches the package-list file at the specified extdocURL location for that package name. When it finds the package name, it prefixes the name with extdocURL.

For there to be no broken links, all of the documentation for the external references must exist at the specified URLs. The javadoc command does not check that these pages exist, but only that the package-list exists.

Multiple Links You can supply multiple -link options to link to any number of externally generated documents. Javadoc 1.2 has a known bug that prevents you from supplying more than one -link options. This was fixed in Javadoc 1.2.2. Specify a different link option for each external document to link to javadoc -link extdocURL1 -link extdocURL2 ... -link extdocURLn com.mypackage where extdocURL1, extdocURL2, ... extdocURLn point respectively to the roots of external documents, each of which contains a file named package-list.

Cross Links Note that bootstrapping might be required when cross-linking two or more documents that were previously generated. If package-list does not exist for either document when you run the javadoc command on the first document, then the package-list does not yet exist for the second document. Therefore, to create the external links, you must regenerate the first document after you generate the second document.

In this case, the purpose of first generating a document is to create its package-list (or you can create it by hand if you are certain of the package names). Then, generate the second document with its external links. The javadoc command prints a warning when a needed external package-list file does not exist.

-linkoffline extdocURL packagelistLoc
    This option is a variation of the -link option. They both create links to Javadoc-generated documentation for externally referenced classes. Use the -linkoffline option when linking to a document on the web when the javadoc command cannot access the document through a web connection. Use the -linkoffline option when package-list file of the external document is not accessible or does not exist at the extdocURL location, but does exist at a different location that can be specified by packageListLoc (typically local). If extdocURL is accessible only on the World Wide Web, then the -linkoffline option removes the constraint that the javadoc command must have a web connection to generate documentation. Another use is as a work-around to update documents: After you have run the javadoc command on a full set of packages, you can run the javadoc command again on a smaller set of changed packages, so that the updated files can be inserted back into the original set. Examples follow. The -linkoffline option takes two arguments. The first is for the string to be embedded in the <a href> links, and the second tells the -linkoffline option where to find package-list:

    •   The extdocURL value is the absolute or relative URL of the directory that contains the external Javadoc-generated documentation you want to link to. When relative, the value should be the relative path from the destination directory (specified with the -d option) to the root of the packages being linked to. For more information, see extdocURL in the -link option.

    •   The packagelistLoc value is the path or URL to the directory that contains the package-list file for the external documentation. This can be a URL (http: or file:) or file path, and can be absolute or relative. When relative, make it relative to the current directory from where the javadoc command was run. Do not include the package-list file name. You can specify multiple -linkoffline options in a specified javadoc command run. Before Javadoc 1.2.2, the -linkfile options could be specified once.

Absolute Links to External Documents You might have a situation where you want to link to the java.lang, java.io and other Java SE packages at http://docs.oracle.com/javase/8/docs/api/index.html

However, your shell does not have web access. In this case, do the following:

1.  Open the package-list file in a browser at http://docs.oracle.com/javase/8/docs/api/package-list

2.  Save the file to a local directory, and point to this local copy with the second argument, packagelistLoc. In this example, the package list file was saved to the current directory (.).

The following command generates documentation for the package com.mypackage with links to the Java SE packages. The generated documentation will contain links to the Object class, for example, in the class trees. Other necessary options, such as -sourcepath, are not shown.

javadoc -linkoffline http://docs.oracle.com/javase/8/docs/api/ .  com.mypackage

Relative Links to External Documents It is not very common to use -linkoffline with relative paths, for the simple reason that the -link option is usually enough. When you use the -linkoffline option, the package-list file is usually local, and when you use relative links, the file you are linking to is also local, so it is usually unnecessary to give a different path for the two arguments to the -linkoffline option When the two arguments are identical, you can use the -link option.

Create a package-list File Manually If a package-list file does not exist yet, but you know what package names your document will link to, then you can manually create your own copy of this file and specify its path with packagelistLoc. An example would be the previous case where the package list for com.spipackage did not exist when com.apipackage was first generated. This technique is useful when you need to generate documentation that links to new external documentation whose package names you know, but which is not yet published. This is also a way of creating package-list files for packages generated with Javadoc 1.0 or 1.1, where package-list files were not generated. Similarly, two companies can share their unpublished package-list files so they can release their cross-linked documentation simultaneously.

Link to Multiple Documents You can include the -linkoffline option once for each generated document you want to refer to:

javadoc -linkoffline extdocURL1 packagelistLoc1 -linkoffline extdocURL2
packagelistLoc2 ...

Update Documents You can also use the -linkoffline option when your project has dozens or hundreds of packages. If you have already run the javadoc command on the entire source tree, then you can quickly make small changes to documentation comments and rerun the javadoc command on a portion of the source tree. Be aware that the second run works properly only when your changes are to documentation comments and not to declarations. If you were to add, remove, or change any declarations from the source code, then broken links could show up in the index, package tree, inherited member lists, Use page, and other places.

First, create a new destination directory, such as update, for this new small run. In this example, the original destination directory is named html. In the simplest example, change directory to the parent of html. Set the first argument of the -linkoffline option to the current directory (.) and set the second argument to the relative path to html, where it can find package-list and pass in only the package names of the packages you want to update:

javadoc -d update -linkoffline . html com.mypackage

When the javadoc command completes, copy these generated class pages in update/com/package (not the overview or index) to the original files in html/com/package.

-linksource
    Creates an HTML version of each source file (with line numbers) and adds links to them from the standard HTML documentation. Links are created for classes, interfaces, constructors, methods, and fields whose declarations are in a source file. Otherwise, links are not created, such as for default constructors and generated classes. This option exposes all private implementation details in the included source files, including private classes, private fields, and the bodies of private methods, regardless of the -public, -package, -protected, and -private options. Unless you also use the -private option, not all private classes or interfaces are accessible through links. Each link appears on the name of the identifier in its declaration. For example, the link to the source code of the Button class would be on the word Button:

    public class Button extends Component implements Accessible

    The link to the source code of the getLabel method in the Button class is on the word getLabel:

    public String getLabel()

-group groupheading packagepattern:packagepattern
    Separates packages on the overview page into whatever groups you specify, one group per table. You specify each group with a different -group option. The groups appear on the page in the order specified on the command line. Packages are alphabetized within a group. For a specified -group option, the packages matching the list of packagepattern expressions appear in a table with the heading groupheading.

    •   The groupheading can be any text and can include white space. This text is placed in the table heading for the group.

    •   The packagepattern value can be any package name at the start of any package name followed by an asterisk (*). The asterisk is the only wildcard allowed and means match any characters. Multiple patterns can be included in a group by separating them with colons (:). If you use an asterisk in a pattern or pattern list, then the pattern list must be inside quotation marks, such as "java.lang*:java.util".
When you do not supply a -group option, all packages are placed in one group with the heading Packages and appropriate subheadings. If the subheadings do not include all documented packages (all groups), then the remaining packages appear in a separate group with the subheading Other Packages. For example, the following javadoc command separates the three documented packages into Core, Extension, and Other Packages. The trailing dot (.) does not appear in java.lang*. Including the dot, such as java.lang.* omits thejava.lang package.

javadoc -group "Core Packages" "java.lang*:java.util"
        -group "Extension Packages" "javax.*"
        java.lang java.lang.reflect java.util javax.servlet java.new

Core Packages java.lang java.lang.reflect java.util Extension Packages javax.servlet Other Packages java.new

-nodeprecated
    Prevents the generation of any deprecated API in the documentation. This does what the -nodeprecatedlist option does, and it does not generate any deprecated API throughout the rest of the documentation. This is useful when writing code when you do not want to be distracted by the deprecated code.

-nodeprecatedlist
    Prevents the generation of the file that contains the list of deprecated APIs (deprecated-list.html) and the link in the navigation bar to that page. The javadoc command continues to generate the deprecated API throughout the rest of the document. This is useful when your source code contains no deprecated APIs, and you want to make the navigation bar cleaner.

-nosince
    Omits from the generated documents the Since sections associated with the @since tags.

-notree
    Omits the class/interface hierarchy pages from the generated documents. These are the pages you reach using the Tree button in the navigation bar. The hierarchy is produced by default.

-noindex
    Omits the index from the generated documents. The index is produced by default.

-nohelp
    Omits the HELP link in the navigation bars at the top and bottom of each page of output.

-nonavbar
    Prevents the generation of the navigation bar, header, and footer, that are usually found at the top and bottom of the generated pages. The -nonavbar option has no affect on the -bottom option. The -nonavbar option is useful when you are interested only in the content and have no need for navigation, such as when you are converting the files to PostScript or PDF for printing only.

-helpfile path\filename
    Specifies the path of an alternate help file path\filename that the HELP link in the top and bottom navigation bars link to. Without this option, the javadoc command creates a help file help-doc.html that is hard-coded in the javadoc command. This option lets you override the default. The file name can be any name and is not restricted to help-doc.html. The javadoc command adjusts the links in the navigation bar accordingly, for example:

    javadoc -helpfile /home/user/myhelp.html java.awt.

-stylesheet path/filename
    Specifies the path of an alternate HTML stylesheet file. Without this option, the javadoc command automatically creates a stylesheet file stylesheet.css that is hard-coded in the javadoc command. This option lets you override the default. The file name can be any name and is not restricted to stylesheet.css, for example:

    javadoc -stylesheet file /home/user/mystylesheet.css com.mypackage

-serialwarn
    Generates compile-time warnings for missing @serial tags. By default, Javadoc 1.2.2 and later versions generate no serial warnings. This is a reversal from earlier releases. Use this option to display the serial warnings, which helps to properly document default serializable fields and writeExternal methods.

-charset name
    Specifies the HTML character set for this document. The name should be a preferred MIME name as specified in the IANA Registry, Character Sets at http://www.iana.org/assignments/character-sets For example, javadoc -charset "iso-8859-1" mypackage inserts the following line in the head of every generated page:

    <META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">

    This META tag is described in the HTML standard (4197265 and 4137321), HTML Document Representation, at http://www.w3.org/TR/REC-html40/charset.html#h-5.2.2 See also the -encoding and -docencoding name options.

-docencoding name
    Specifies the encoding of the generated HTML files. The name should be a preferred MIME name as specified in the IANA Registry, Character Sets at http://www.iana.org/assignments/character-sets If you omit the -docencoding option but use the -encoding option, then the encoding of the generated HTML files is determined by the -encoding option, for example: javadoc -docencoding "iso-8859-1" mypackage. See also the -encoding and -docencoding name options.

-keywords
    Adds HTML keyword <META> tags to the generated file for each class. These tags can help search engines that look for <META> tags find the pages. Most search engines that search the entire Internet do not look at <META> tags, because pages can misuse them. Search engines offered by companies that confine their searches to their own website can benefit by looking at <META> tags. The <META> tags include the fully qualified name of the class and the unqualified names of the fields and methods. Constructors are not included because they are identical to the class name. For example, the class String starts with these keywords:

    <META NAME="keywords" CONTENT="java.lang.String class">
    <META NAME="keywords" CONTENT="CASE_INSENSITIVE_ORDER">
    <META NAME="keywords" CONTENT="length()">
    <META NAME="keywords" CONTENT="charAt()">

-tag tagname:Xaoptcmf:"taghead"
    Enables the javadoc command to interpret a simple, one-argument @tagname custom block tag in documentation comments. For the javadoc command to spell-check tag names, it is important to include a -tag option for every custom tag that is present in the source code, disabling (with X) those that are not being output in the current run.The colon (:) is always the separator. The -tag option outputs the tag heading taghead in bold, followed on the next line by the text from its single argument. Similar to any block tag, the argument text can contain inline tags, which are also interpreted. The output is similar to standard one-argument tags, such as the @return and @author tags. Omitting a value for taghead causes tagname to be the heading. Placement of tags: The Xaoptcmf arguments determine where in the source code the tag is allowed to be placed, and whether the tag can be disabled (using X). You can supply either a, to allow the tag in all places, or any combination of the other letters: X (disable tag) a (all) o (overview) p (packages) t (types, that is classes and interfaces) c (constructors) m (methods) f (fields) Examples of single tags: An example of a tag option for a tag that can be used anywhere in the source code is: -tag todo:a:"To Do:". If you want the @todo tag to be used only with constructors, methods, and fields, then you use: -tag todo:cmf:"To Do:". Notice the last colon (:) is not a parameter separator, but is part of the heading text. You would use either tag option for source code that contains the @todo tag, such as: @todo The documentation for this method needs work. Colons in tag names: Use a backslash to escape a colon that you want to use in a tag name. Use the -tag ejb\\:bean:a:"EJB Bean:" option for the following documentation comment:

    /**
     * @ejb:bean
     */

    Spell-checking tag names: Some developers put custom tags in the source code that they do not always want to output. In these cases, it is important to list all tags that are in the source code, enabling the ones you want to output and disabling the ones you do not want to output. The presence of X disables the tag, while its absence enables the tag. This gives the javadoc command enough information to know whether a tag it encounters is unknown, which is probably the results of a typographical error or a misspelling. The javadoc command prints a warning in these cases. You can add X to the placement values already present, so that when you want to enable the tag, you can simply delete the X. For example, if the @todo tag is a tag that you want to suppress on output, then you would use: -tag todo:Xcmf:"To Do:". If you would rather keep it simple, then use this: -tag todo:X. The syntax -tag todo:X works even when the @todo tag is defined by a taglet. Order of tags: The order of the -tag and -taglet options determines the order the tags are output. You can mix the custom tags with the standard tags to intersperse them. The tag options for standard tags are placeholders only for determining the order. They take only the standard tag's name. Subheadings for standard tags cannot be altered. This is illustrated in the following example.If the -tag option is missing, then the position of the -taglet option determines its order. If they are both present, then whichever appears last on the command line determines its order. This happens because the tags and taglets are processed in the order that they appear on the command line. For example, if the -taglet and -tag options have the name todo value, then the one that appears last on the command line determines the order. Example of a complete set of tags: This example inserts To Do after Parameters and before Throws in the output. By using X, it also specifies that the @example tag might be encountered in the source code that should not be output during this run. If you use the @argfile tag, then you can put the tags on separate lines in an argument file similar to this (no line continuation characters needed):

    -tag param
    -tag return
    -tag todo:a:"To Do:"
    -tag throws
    -tag see
    -tag example:X

    When the javadoc command parses the documentation comments, any tag encountered that is neither a standard tag nor passed in with the -tag or -taglet options is considered unknown, and a warning is thrown. The standard tags are initially stored internally in a list in their default order. Whenever the -tag options are used, those tags get appended to this list. Standard tags are moved from their default position. Therefore, if a -tag option is omitted for a standard tag, then it remains in its default position. Avoiding conflicts: If you want to create your own namespace, then you can use a dot-separated naming convention similar to that used for packages: com.mycompany.todo. Oracle will continue to create standard tags whose names do not contain dots. Any tag you create will override the behavior of a tag by the same name defined by Oracle. If you create a @todo tag or taglet, then it always has the same behavior you define, even when Oracle later creates a standard tag of the same name. Annotations vs. Javadoc tags: In general, if the markup you want to add is intended to affect or produce documentation, then it should be a Javadoc tag. Otherwise, it should be an annotation. See Custom Tags and Annotations in How to Write Doc Comments for the Javadoc Tool at http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html#annotations You can also create more complex block tags or custom inline tags with the -taglet option.

-taglet class
    Specifies the class file that starts the taglet used in generating the documentation for that tag. Use the fully qualified name for the class value. This taglet also defines the number of text arguments that the custom tag has. The taglet accepts those arguments, processes them, and generates the output. For extensive documentation with example taglets, see: Taglet Overview at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/taglet/overview.html Taglets are useful for block or inline tags. They can have any number of arguments and implement custom behavior, such as making text bold, formatting bullets, writing out the text to a file, or starting other processes. Taglets can only determine where a tag should appear and in what form. All other decisions are made by the doclet. A taglet cannot do things such as remove a class name from the list of included classes. However, it can execute side effects, such as printing the tag's text to a file or triggering another process. Use the -tagletpath option to specify the path to the taglet. The following example inserts the To Do taglet after Parameters and ahead of Throws in the generated pages. Alternately, you can use the -taglet option in place of its -tag option, but that might be difficult to read.

    -taglet com.sun.tools.doclets.ToDoTaglet
    -tagletpath /home/taglets
    -tag return
    -tag param
    -tag todo
    -tag throws
    -tag see

-tagletpath tagletpathlist
    Specifies the search paths for finding taglet class files. The tagletpathlist can contain multiple paths by separating them with a colon (:). The javadoc command searches all subdirectories of the specified paths.

-docfilesubdirs
    Enables deep copying of doc-files directories. Subdirectories and all contents are recursively copied to the destination. For example, the directory doc-files/example/images and all of its contents would be copied. There is also an option to exclude subdirectories.

-excludedocfilessubdir name1:name2
    Excludes any doc-files subdirectories with the specified names. This prevents the copying of SCCS and other source-code-control subdirectories.

-noqualifier all | packagename1:packagename2...
    Omits qualifying package names from class names in output. The argument to the -noqualifier option is either all (all package qualifiers are omitted) or a colon-separate list of packages, with wild cards, to be removed as qualifiers. The package name is removed from places where class or interface names appear. See Process Source Files. The following example omits all package qualifiers: -noqualifier all. The following example omits java.lang and java.io package qualifiers: -noqualifier java.lang:java.io. The following example omits package qualifiers starting with java, and com.sun subpackages, but not javax: -noqualifier java.*:com.sun.*. Where a package qualifier would appear due to the previous behavior, the name can be suitably shortened. See How a Name Appears. This rule is in effect whether or not the -noqualifier option is used.

-notimestamp
    Suppresses the time stamp, which is hidden in an HTML comment in the generated HTML near the top of each page. The -notimestamp option is useful when you want to run the javadoc command on two source bases and get the differences between diff them, because it prevents time stamps from causing a diff (which would otherwise be a diff on every page). The time stamp includes the javadoc command release number, and currently appears similar to this: <!-- Generated by javadoc (build 1.5.0_01) on Thu Apr 02 14:04:52 IST 2009 -->.

-nocomment
    Suppresses the entire comment body, including the main description and all tags, and generate only declarations. This option lets you reuse source files that were originally intended for a different purpose so that you can produce skeleton HTML documentation at the early stages of a new project.

-sourcetab tablength
    Specifies the number of spaces each tab uses in the source.

COMMAND-LINE ARGUMENT FILES
To shorten or simplify the javadoc command, you can specify one or more files that contain arguments to the javadoc command (except -J options). This enables you to create javadoc commands of any length on any operating system.

An argument file can include javac options and source file names in any combination. The arguments within a file can be space-separated or newline-separated. If a file name contains embedded spaces, then put the whole file name in double quotation marks.

File Names within an argument file are relative to the current directory, not the location of the argument file. Wild cards (*) are not allowed in these lists (such as for specifying *.java). Using the at sign (@) to recursively interpret files is not supported. The -J options are not supported because they are passed to the launcher, which does not support argument files.

When you run the javadoc command, pass in the path and name of each argument file with the @ leading character. When the javadoc command encounters an argument beginning with the at sign (@), it expands the contents of that file into the argument list.

Example 1 Single Argument File

You could use a single argument file named argfile to hold all javadoc command arguments: javadoc @argfile. The argument file contains the contents of both files, as shown in the next example.

Example 2 Two Argument Files

You can create two argument files: One for the javadoc command options and the other for the package names or source file names. Notice the following lists have no line-continuation characters.

Create a file named options that contains:

-d docs-filelist
-use
-splitindex
-windowtitle 'Java SE 7 API Specification'
-doctitle 'Java SE 7 API Specification'
-header '<b>Java™ SE 7</b>'
-bottom 'Copyright &copy; 1993-2011 Oracle and/or its affiliates. All rights reserved.'
-group "Core Packages" "java.*"
-overview /java/pubs/ws/1.7.0/src/share/classes/overview-core.html
-sourcepath /java/pubs/ws/1.7.0/src/share/classes

Create a file named packages that contains:

com.mypackage1
com.mypackage2
com.mypackage3

Run the javadoc command as follows:

javadoc @options @packages

Example 3 Argument Files with Paths

The argument files can have paths, but any file names inside the files are relative to the current working directory (not path1 or path2):

javadoc @path1/options @path2/packages

Example 4 Option Arguments

The following example saves an argument to a javadoc command option in an argument file. The -bottom option is used because it can have a lengthy argument. You could create a file named bottom to contain the text argument:

<font size="-1">
    <a href="http://bugreport.sun.com/bugreport/">Submit a bug or feature</a><br/>
    Copyright &copy; 1993, 2011, Oracle and/or its affiliates. All rights reserved. <br/>
    Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
    Other names may be trademarks of their respective owners.</font>

Run the javadoc command as follows:javadoc -bottom @bottom @packages.

You can also include the -bottom option at the start of the argument file and run the javadoc command as follows: javadoc @bottom @packages.

RUNNING THE JAVADOC COMMAND
The release number of the javadoc command can be determined with the javadoc -J-version option. The release number of the standard doclet appears in the output stream. It can be turned off with the -quiet option.

Use the public programmatic interface to call the javadoc command from within programs written in the Java language. This interface is in com.sun.tools.javadoc.Main (and the javadoc command is reentrant). For more information, see The Standard Doclet at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/standard-doclet.html#runningprogrammatically

The following instructions call the standard HTML doclet. To call a custom doclet, use the -doclet and -docletpath options. See Doclet Overview at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/doclet/overview.html

  SIMPLE EXAMPLES
You can run the javadoc command on entire packages or individual source files. Each package name has a corresponding directory name.

In the following examples, the source files are located at /home/src/java/awt/*.java. The destination directory is /home/html.

Document One or More Packages To document a package, the source files for that package must be located in a directory that has the same name as the package.

If a package name has several identifiers (separated by dots, such as java.awt.color), then each subsequent identifier must correspond to a deeper subdirectory (such as java/awt/color).

You can split the source files for a single package among two such directory trees located at different places, as long as -sourcepath points to them both. For example, src1/java/awt/color and src2/java/awt/color.

You can run the javadoc command either by changing directories (with the cd command) or by using the -sourcepath option. The following examples illustrate both alternatives.

Example 1 Recursive Run from One or More Packages

This example uses -sourcepath so the javadoc command can be run from any directory and -subpackages (a new 1.4 option) for recursion. It traverses the subpackages of the java directory excluding packages rooted at java.net and java.lang. Notice this excludes java.lang.ref, a subpackage of java.lang. To also traverse down other package trees, append their names to the -subpackages argument, such as java:javax:org.xml.sax.

javadoc -d /home/html -sourcepath /home/src -subpackages java -exclude

Example 2 Change to Root and Run Explicit Packages

Change to the parent directory of the fully qualified package. Then, run the javadoc command with the names of one or more packages that you want to document:

cd /home/src/
javadoc -d /home/html java.awt java.awt.event

To also traverse down other package trees, append their names to the -subpackages argument, such as java:javax:org.xml.sax.

Example 3 Run from Any Directory on Explicit Packages in One Tree

In this case, it does not matter what the current directory is. Run the javadoc command and use the -sourcepath option with the parent directory of the top-level package. Provide the names of one or more packages that you want to document:

javadoc -d /home/html -sourcepath /home/src java.awt java.awt.event

Example 4 Run from Any Directory on Explicit Packages in Multiple Trees

Run the javadoc command and use the -sourcepath option with a colon-separated list of the paths to each tree's root. Provide the names of one or more packages that you want to document. All source files for a specified package do not need to be located under a single root directory, but they must be found somewhere along the source path.

javadoc -d /home/html -sourcepath /home/src1:/home/src2 java.awt java.awt.event

The result is that all cases generate HTML-formatted documentation for the public and protected classes and interfaces in packages java.awt and java.awt.event and save the HTML files in the specified destination directory. Because two or more packages are being generated, the document has three HTML frames: one for the list of packages, another for the list of classes, and the third for the main class pages.

Document One or More Classes The second way to run the javadoc command is to pass one or more source files. You can run javadoc either of the following two ways: by changing directories (with the cd command) or by fully specifying the path to the source files. Relative paths are relative to the current directory. The -sourcepath option is ignored when passing source files. You can use command-line wild cards, such as an asterisk (*), to specify groups of classes.

Example 1 Change to the Source Directory

Change to the directory that holds the source files. Then run the javadoc command with the names of one or more source files you want to document.

This example generates HTML-formatted documentation for the classes Button, Canvas, and classes that begin with Graphics. Because source files rather than package names were passed in as arguments to the javadoc command, the document has two frames: one for the list of classes and the other for the main page.

cd /home/src/java/awt
javadoc -d /home/html Button.java Canvas.java Graphics*.java

Example 2 Change to the Root Directory of the Package

This is useful for documenting individual source files from different subpackages off of the same root. Change to the package root directory, and supply the source files with paths from the root.

cd /home/src/
javadoc -d /home/html java/awt/Button.java java/applet/Applet.java

Example 3 Document Files from Any Directory

In this case, it does not matter what the current directory is. Run the javadoc command with the absolute path (or path relative to the current directory) to the source files you want to document.

javadoc -d /home/html /home/src/java/awt/Button.java
/home/src/java/awt/Graphics*.java

Document Packages and Classes You can document entire packages and individual classes at the same time. Here is an example that mixes two of the previous examples. You can use the -sourcepath option for the path to the packages but not for the path to the individual classes.

javadoc -d /home/html -sourcepath /home/src java.awt
/home/src/java/applet/Applet.java

  REAL-WORLD EXAMPLES
The following command-line and makefile versions of the javadoc command run on the Java platform APIs. It uses 180 MB of memory to generate the documentation for the 1500 (approximately) public and protected classes in the Java SE 1.2. Both examples use absolute paths in the option arguments, so that the same javadoc command can be run from any directory.

Command-Line Example The following command might be too long for some shells. You can use a command-line argument file (or write a shell script) to overcome this limitation.

In the example, packages is the name of a file that contains the packages to process, such as java.appletjava.lang. None of the options should contain any newline characters between the single quotation marks. For example, if you copy and paste this example, then delete the newline characters from the -bottom option.

javadoc -sourcepath /java/jdk/src/share/classes \
-overview /java/jdk/src/share/classes/overview.html \
-d /java/jdk/build/api \
-use \
-splitIndex \
-windowtitle 'Java Platform, Standard Edition 7 API Specification' \
-doctitle 'Java Platform, Standard Edition 7 API Specification' \
-header '<b>Java™ SE 7</b>' \
-bottom '<font size="-1">
<a href="http://bugreport.sun.com/bugreport/">Submit a bug or feature</a><br/>
Copyright &copy; 1993, 2011, Oracle and/or its affiliates. All rights reserved.<br/>
Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
Other names may be trademarks of their respective owners.</font>' \
-group "Core Packages" "java.*:com.sun.java.*:org.omg.*" \
-group "Extension Packages" "javax.*" \
-J-Xmx180m \
@packages

Programmatic Interface The Javadoc Access API enables the user to invoke the Javadoc tool directly from a Java application without executing a new process.

For example, the following statements are equivalent to the command javadoc -d /home/html -sourcepath /home/src -subpackages java -exclude java.net:java.lang com.example:

import javax.tools.DocumentationTool;
import javax.tools.ToolProvider;

public class JavaAccessSample{
    public static void main(String[] args){
        DocumentationTool javadoc = ToolProvider.getSystemDocumentationTool();
        int rc = javadoc.run( null, null, null,
                 "-d", "/home/html",
                 "-sourcepath", "home/src",
                 "-subpackages", "java",
                 "-exclude", "java.net:java.lang",
                 "com.example");
     }
 }

The first three arguments of the run method specify input, standard output, and standard error streams. Null is the default value for System.in, System.out, and System.err, respectively.

  THE MAKEFILE EXAMPLE
This is an example of a GNU makefile. Single quotation marks surround makefile arguments. For an example of a Windows makefile, see the makefiles section of the Javadoc FAQ at http://www.oracle.com/technetwork/java/javase/documentation/index-137483.html#makefiles

javadoc -sourcepath $(SRCDIR)              \   /* Sets path for source files   */
        -overview $(SRCDIR)/overview.html  \   /* Sets file for overview text  */
        -d /java/jdk/build/api             \   /* Sets destination directory   */
        -use                               \   /* Adds "Use" files             */
        -splitIndex                        \   /* Splits index A-Z             */
        -windowtitle $(WINDOWTITLE)        \   /* Adds a window title          */
        -doctitle $(DOCTITLE)              \   /* Adds a doc title             */
        -header $(HEADER)                  \   /* Adds running header text     */
        -bottom $(BOTTOM)                  \   /* Adds text at bottom          */
        -group $(GROUPCORE)                \   /* 1st subhead on overview page */
        -group $(GROUPEXT)                 \   /* 2nd subhead on overview page */
        -J-Xmx180m                         \   /* Sets memory to 180MB         */
        java.lang java.lang.reflect        \   /* Sets packages to document    */
        java.util java.io java.net         \
        java.applet

WINDOWTITLE = 'Java™ SE 7 API Specification'
DOCTITLE = 'Java™ Platform Standard Edition 7 API Specification'
HEADER = '<b>Java™ SE 7</font>'
BOTTOM = '<font size="-1">
      <a href="http://bugreport.sun.com/bugreport/">Submit a bug or feature</a><br/>
      Copyright &copy; 1993, 2011, Oracle and/or its affiliates. All rights reserved.<br/>
      Oracle is a registered trademark of Oracle Corporation and/or its affiliates.
      Other names may be trademarks of their respective owners.</font>'
GROUPCORE = '"Core Packages" "java.*:com.sun.java.*:org.omg.*"'
GROUPEXT  = '"Extension Packages" "javax.*"'
SRCDIR = '/java/jdk/1.7.0/src/share/classes'

  NOTES

•   If you omit the -windowtitle option, then the javadoc command copies the document title to the window title. The -windowtitle option text is similar to the the -doctitle option, but without HTML tags to prevent those tags from appearing as raw text in the window title.

•   If you omit the -footer option, then the javadoc command copies the header text to the footer.

•   Other important options you might want to use, but were not needed in the previous example, are the -classpath and -link options.

GENERAL TROUBLESHOOTING

•   The javadoc command reads only files that contain valid class names. If the javadoc command is not correctly reading the contents of a file, then verify that the class names are valid. See Process Source Files.

•   See the Javadoc FAQ for information about common bugs and for troubleshooting tips at http://www.oracle.com/technetwork/java/javase/documentation/index-137483.html

ERRORS AND WARNINGS
Error and warning messages contain the file name and line number to the declaration line rather than to the particular line in the documentation comment.

For example, this message error: cannot read: Class1.java means that the javadoc command is trying to load Class1.java in the current directory. The class name is shown with its path (absolute or relative).

ENVIRONMENT

CLASSPATH
    CLASSPATH is the environment variable that provides the path that the javadoc command uses to find user class files. This environment variable is overridden by the -classpath option. Separate directories with a semicolon for Windows or a colon for Oracle Solaris. Windows example: .;C:\classes;C:\home\java\classes Oracle Solaris example: .:/home/classes:/usr/local/java/classes.

SEE ALSO

•   javac(1)

•   java(1)

•   jdb(1)

•   javap(1)

RELATED DOCUMENTS

•   Javadoc Technology at http://docs.oracle.com/javase/8/docs/technotes/guides/javadoc/index.html

•   How Classes Are Found http://docs.oracle.com/javase/8/docs/technotes/tools/findingclasses.html

•   How to Write Doc Comments for the Javadoc Tool http://www.oracle.com/technetwork/java/javase/documentation/index-137868.html

•   URL Memo, Uniform Resource Locators http://www.ietf.org/rfc/rfc1738.txt

•   HTML standard, HTML Document Representation (4197265 and 4137321) http://www.w3.org/TR/REC-html40/charset.html#h-5.2.2